* --------------- Programa WINPRG 3.04  ------------------------*
* --------------- Autor: Mustafa Lpez Nicols  -----------------*
* --------------- e-mail: mustafalopez@gmail.com  ---------------*
*-----------------Visor Estructura DBF --------------------------*
#define __SYSDATA__

#include "minigui.ch"

*----------------------*
PROCEDURE AUXILIAR()
*----------------------*

    REQUEST DBFCDX , DBFFPT
    RDDSETDEFAULT( "DBFCDX" )

    REQUEST DBFNTX , DBFDBT
    RDDSETDEFAULT( "DBFNTX" )

PUBLIC  ficher , fichera ,  ficheru , aFieldNames , aHeaders , aWidths , i
PUBLIC aChecbo , aCIntxcdx , aNomFich

OpenTablesZx()

SET DATE FRENCH
SET CENTURY ON
SET ESCAPE ON
SET BROWSESYNC OFF
SET NAVIGATION EXTENDED

    DEFINE WINDOW Win_4x ;
        AT 0,0           ;
        WIDTH 640 HEIGHT 480    ;
        BACKCOLOR {0, 128, 192} ;
        TITLE 'Browse'   ; 
        icon "Logo"      ;
        CHILD NOMINIMIZE NOMAXIMIZE  
        ON KEY ESCAPE ACTION Win_4x.Release

        DEFINE MAIN MENU
            POPUP '&Salir'
                ITEM '&Salir' ACTION Win_4x.Release
            END POPUP
        END MENU

        DEFINE STATUSBAR FONT 'Arial'
            STATUSITEM '[Esc] -> Cancelar'WIDTH 20
            STATUSITEM '[Enter] / Double Click Editar' WIDTH 160
            STATUSITEM '[Alt]+[ A ]  -> Nuevo Registro' WIDTH 150
            STATUSITEM '[Supr] -> Borrar Registro' WIDTH 140
            BACKCOLOR {0, 128, 192}
        END STATUSBAR

       minuscula := ALLTRIM(aNomFich)

       @ 10, 77 LABEL lbl_03 VALUE "Browse Base Datos " + LOWER ( minuscula) + ".dbf" AUTOSIZE ;
        FONT "Verdana" SIZE 17 BOLD ITALIC ;
         FONTCOLOR BLACK TRANSPARENT
       @ 07, 74 LABEL lbl_04 VALUE "Browse Base Datos " + LOWER ( minuscula)  + ".dbf" AUTOSIZE ;
         FONT "Verdana" SIZE 17 BOLD ITALIC ;
         FONTCOLOR { 151, 223, 255 } TRANSPARENT

RESTORE FROM MEMDBF.mem ADDITIVE

ficher  := "New\"+ALLTRIM(aNomFich)
ficheru := "New\"+ALLTRIM(aNomFich)+".DBF"
fichera := ALLTRIM(aNomFich)
*------------------------------------------*
 IF .NOT. FILE (ficheru)
          MSGSTOP("Fichero No Existe","Atencion")
          CLOSE DATABASES
          RETURN NIL      
 ENDIF
*------------------------------------------*

aFieldNames :=  {}
aHeaders := {}
aWidths  := {}

*-------- Letra y Color ----------*
 cFont     := 'Arial'
 cSize     :=  9
 cFontColr := {000,000,107}
 cBackColr := {255,255,211}
*---------------------------------*


		For i := 1 To FCount()
			aadd ( aFieldNames , fichera + '->' + FieldName(i) )
			aadd ( aHeaders , FieldName(i) )
			aadd ( aWidths , 160 )
		Next i

             DEFINE BROWSE Browse_1
                      ROW 40
                      COL 10
                      WIDTH 610
                      HEIGHT 305           
                      HEADERS aHeaders
                      WIDTHS aWidths
                      WORKAREA &(fichera)
                      FIELDS aFieldNames
                      ALLOWEDIT .T.
                      ALLOWAPPEND .T.
                      LOCK .T.
                      ALLOWDELETE .T.
                      FONTNAME  cFont
                      FONTSIZE  cSize
                      FONTITALIC .T.
                      FONTBOLD .T.
                      TOOLTIP  'Fichero:' + SPACE(1) + minuscula    
                      FONTCOLOR cFontColr
                      BACKCOLOR cBackColr       
             END BROWSE

             DEFINE BUTTON Button_1D                 
                     ROW    360
                     COL    170
                     WIDTH  140
                     HEIGHT 028
                     ACTION Appe_Record()                 
                     CAPTION 'Nuevo Registro'
                     FONTNAME "Arial"
                     FONTSIZE 8
                     TOOLTIP 'Alta Nuevo Registro'  
                     FONTBOLD .T.
                     FONTITALIC .T.
                     FONTUNDERLINE .F.
                     FONTSTRIKEOUT .F.
                     ONGOTFOCUS Nil
                     ONLOSTFOCUS Nil
                     HELPID Nil
                     FLAT .F.
                     TABSTOP .T.
                     VISIBLE .T.
                     TRANSPARENT .F.
                     MULTILINE .F.
                     PICTURE "Bmp\NewX.Bmp"
                     PICTALIGNMENT LEFT
             END BUTTON

             DEFINE BUTTON Button_2D               
                     ROW    360
                     COL    320
                     WIDTH  140
                     HEIGHT 028
                     ACTION Dele_Record()               
                     CAPTION 'Borrar Registro'   
                     FONTNAME "Arial"
                     FONTSIZE 8
                     TOOLTIP 'Borrar Registro'   
                     FONTBOLD .T.
                     FONTITALIC .T.
                     FONTUNDERLINE .F.
                     FONTSTRIKEOUT .F.
                     ONGOTFOCUS Nil
                     ONLOSTFOCUS Nil
                     HELPID Nil
                     FLAT .F.
                     TABSTOP .T.
                     VISIBLE .T.
                     TRANSPARENT .F.
                     MULTILINE .F.
                     PICTURE "Bmp\Erase2.Bmp"
                     PICTALIGNMENT LEFT
             END BUTTON

    END WINDOW

    CENTER WINDOW Win_4x

    ACTIVATE WINDOW Win_4x

    USE

Return Nil
*---------------------------------------------------------*
Procedure OpenTablesZx()

RESTORE FROM MEMDBF.mem ADDITIVE

 fichero := "New\"+ALLTRIM(aNomFich)+".DBF"

 ficher  := "New\"+ALLTRIM(aNomFich)

 fichNTX := "New\"+ALLTRIM(aNomFich)+".NTX"

 fichCDX := "New\"+ALLTRIM(aNomFich)+".CDX"
*------------------------------------------*
 IF .NOT. FILE (fichero)
          CLOSE DATABASES
          RETURN NIL      
 ENDIF
*-------------------  True ----------------*
   IF aChecbo = "True"
    IF aCIntxcdx = "True"
     IF .NOT. FILE ( fichNTX )
       MSGSTOP("Fichero -> NTX,  No Existe","Atencin !!!")
       CLOSE DATABASES
       USE &ficher
       PACK
       RETURN NIL
     ENDIF
     IF .NOT. FILE (fichero)
          MSGSTOP("Fichero No Existe","Atencion")
          CLOSE DATABASES
          RETURN NIL
        ELSE

       USE &ficher INDEX &ficher Via "DBFNTX"
       PACK

     IF RECNO() < 1
         APPEND BLANK
         GO TOP
         RETURN NIL
       ELSE
         GO TOP
         RETURN NIL
      ENDIF
    ENDIF
   ENDIF
 ENDIF
*---------- True  False ----------------*
  IF aChecbo = "True"
     IF aCIntxcdx = "False"
       IF .NOT. FILE (  fichCDX )
        MSGSTOP("Fichero -> CDX,  No Existe","Atencin !!!")
        CLOSE DATABASES
        USE &ficher
        PACK
        RETURN NIL
       ENDIF
       IF .NOT. FILE (fichero)
          MSGSTOP("Fichero No Existe","Atencion")
          CLOSE DATABASES
          RETURN NIL
        ELSE
      USE &ficher INDEX &ficher Via "DBFCDX"
      PACK

   IF RECNO() < 1
         APPEND BLANK
         GO TOP
         RETURN NIL
       ELSE
         GO TOP
         RETURN NIL
      ENDIF
     ENDIF
    ENDIF
  ENDIF
*--------------Sin Index ------------------*
 IF .NOT. FILE (fichero)
      MSGSTOP("Fichero No Existe","Atencion")
       CLOSE DATABASES
       RETURN NIL
      ELSE
       USE &ficher
       PACK

     IF RECNO() < 1
         APPEND BLANK
         GO TOP
         RETURN NIL
       ELSE
         GO TOP
         RETURN NIL
     ENDIF
  ENDIF

Return NIL

*------------------------------------------*
Procedure Appe_Record()
*------------------------------------------*
  RESTORE FROM MEMDBF.mem ADDITIVE

  USE &ficher
  APPEND BLANK
  GO BOTTOM

    Win_4x.Browse_1.Value := &(ficher)->( RecNo() )         
    Win_4x.Browse_1.Refresh
    Win_4x.Browse_1.SetFocus

Return

*------------------------------------------*
Procedure Dele_Record()
*------------------------------------------*
   Local vRecnoX := Win_4x.Browse_1.Value
	
   Goto vRecnoX
	
   IF MsgYesNo("Est Seguro ?","Eliminar Registro") = .T.    
	 Delete
         PACK
	 Win_4x.Browse_1.Value := 1
	 Win_4x.Browse_1.Refresh
	 Win_4x.Browse_1.SetFocus
   End

Return Nil





