* --------------- Programa WINPRG 3.04  ------------------------*
* --------------- Autor: Lucho Miranda --------------------------*
* --------------- e-mail: ElSalnes@Telefonica.net ---------------*
*---------------- Rutina de Impresora   13-07-2009 --------------*

#define __SYSDATA__

#include "Minigui.ch"
* #include "miniprint.ch"

*---------------------------*
FUNCTION PrintFilesPRG()
*---------------------------*

LOCAL cFile :=GetFilePrint()

*---------------------------------------------------------------------*
*    Fecha           : 13-07-2009
*    Contribucin de : Lucho Miranda 'ElSalmes'
*    Mail            : ElSalnes@Telefonica.NET
*---------------------------------------------------------------------*
DECLARE WINDOW ( Win_1I )

DEFINE WINDOW Win_1I  AT 0060, 0207 WIDTH 0438 HEIGHT 0306 ;
   TITLE "Imprimir ArchivosPrg()" BACKCOLOR {236,233,216} ;
   NOSIZE NOMAXIMIZE CHILD     

   ON KEY ESCAPE ACTION Win_1I.Release

   @ 0195, 0050 FRAME Frame_1I CAPTION "" WIDTH 0332 HEIGHT 0053;
   FONT "Ms Sans Serif" SIZE 0011 FONTCOLOR {0,0,0} ;
   BACKCOLOR {236,233,216}

   @ 0057, 0016 FRAME Frame_2I CAPTION "Archivo a Imprimir:" ;
   WIDTH 0398 HEIGHT 0110 FONT "MS Sans Serif" SIZE 0010     ;
   FONTCOLOR {224,188,105}

   @ 010, 108 LABEL Label_1I VALUE "UTILIDAD PARA IMPRIMIR"     +;
   CHR(13) + "Archivos.PRG" CENTERALIGN                          ;
   WIDTH 0228 HEIGHT 0034 FONT "Times NEW Roman" SIZE 0012 BOLD  ;
   BACKCOLOR {236,233,216} FONTCOLOR {0,0,0}

   @ 0084, 0032 TEXTBOX Get_1I VALUE cFile WIDTH 366 HEIGHT 0024 ;
   FONT "Ms Sans Serif" SIZE 0011 FONTCOLOR {0,0,0}              ;
   ON ENTER  IIF(EMPTY(Win_1I.Get_1I.Value) ==.T.,( Win_1I.Hide   ,;
   Win_1I.Get_1I.Value :=GetFilePrint(),Win_1I.Show ,Win_1I.Get_1I.SetFocus),);
   BACKCOLOR {255,255,255}

   @ 132, 138 CHECKBOX Check_1I CAPTION "Impresin Apaisada" VALUE .F. ;
   WIDTH 158 HEIGHT  20 FONT "Palatino Linotype" SIZE 010 BOLD         ;
   BACKCOLOR {236,233,216} FONTCOLOR {0,0,0}

   @ 0214, 0066 BUTTON Button_1I                        ;
   CAPTION "&Archivo" TOOLTIP  "Buscar Archivo para Imprimir" ;
   WIDTH 0080 HEIGHT 0024                               ;
   FONT "Ms Sans Serif" SIZE 0011 ACTION ( Win_1I.Hide ,;
   Win_1I.Get_1I.Value :=GetFilePrint(),Win_1I.Show ,Win_1I.Get_1I.SetFocus)

   @ 0214, 0178 BUTTON Button_2I                        ;
   CAPTION "&Imprimir" TOOLTIP "Imprimir Archivo"       ;
   WIDTH 0080 HEIGHT 0024                               ;
   FONT "Ms Sans Serif" SIZE 0011                       ;
   ACTION ( Win_1I.Hide                                ,;
   PrintFile(Win_1I.Get_1I.Value,Win_1I.Check_1I.Value)   ,;
   Win_1I.Show )

   @ 0214, 0288 BUTTON Button_3I                                 ;
   CAPTION "&Salir" TOOLTIP "Cerrar esta Utilidad de Impresin"  ;
   WIDTH 0080 HEIGHT 0024                                        ;
   FONT "Ms Sans Serif" SIZE 0011 ACTION  Win_1I.Release

END      WINDOW
CENTER   WINDOW Win_1I
ACTIVATE WINDOW Win_1I

RETURN(NIL)

*-----------------------------------------------------*
*               Funciones Auxiliares:
*-----------------------------------------------------*

STATIC PROCEDURE GetFilePrint()
LOCAL cTitl :="Elegir Archivo para Imprimir..."
LOCAL cFile :=GETFILE({{"Archivos: PRG","*.PRG"}} ,cTitl,"\New", .F. , .T. )

RETURN(cFile)

*---------------------------------------*
STATIC PROCEDURE FileTrue(cFile)
LOCAL lFile :=.T.

DO CASE
CASE EMPTY(cFile) ==.T. ;lFile :=.F.
   
   MSGSTOP("Falta el nombre del archivo","Atencin !!!")

CASE FILE(cFile) ==.F.  ;lFile :=.F.

   MSGSTOP("Archivo no encontrado:" + CHR(13) + CHR(13) + cFile,"Error...")   
   
ENDCASE

RETURN( lFile )

*----------------------------------------*

STATIC PROCEDURE PrintFile(cFile,lApaisado)
LOCAL nMargen :=20
LOCAL  lPrint :=.F.

IIF(VALTYPE(lApaisado) <>"L" ,lApaisado := .F. ,  )

DO CASE
CASE lApaisado ==.T. ;nLinsPag :=47
CASE lApaisado ==.F. ;nLinsPag :=66
ENDCASE

cTexto :=MEMOREAD(cFile)

IF FileTrue(cFile) ==.T.

   PrintTexto(RTRIM(MEMOREAD(cFile)),nMargen,nLinsPag,lApaisado)

ENDIF

RETURN(NIL)

*-----------------------------------------*

STATIC PROCEDURE PrintTexto(cTexto,nMargen,nLinsPag,lApaisado)
LOCAL lPrinter  :=IIF(LEN(aPrinters()) <>00,.T.,.F.)
LOCAL nApaisado :=IIF(lApaisado ==.F.,01,02)
LOCAL aLineas   :=HB_ATOKENS( cTexto ,CRLF )
LOCAL nLineas   :=LEN(aLineas)
LOCAL nPaginas  :=INT( nLineas / nLinsPag )
LOCAL nRowIni   :=07
LOCAL nLinNew   :=01

LOCAL   lPrint  :=.F.

IIF( (nPaginas * nLinsPag) <> nLineas ,nPaginas +=01, )

IF lPrinter ==.T.
  SELECT PRINTER DEFAULT TO PRINT ORIENTATION nApaisado PREVIEW ;ELSE
  SELECT PRINTER DIALOG  TO PRINT PREVIEW
ENDIF

START PRINTDOC
   
   FOR nPagina := 1 TO nPaginas
         
      START PRINTPAGE
         
         @ nRowIni,nMargen PRINT "Pagina N " +;
         STRZERO(nPagina ,03) + " De "           +;
         STRZERO(nPaginas,03) FONT "Courier New" SIZE 10
         
         nRowLin :=10
         
         FOR nLinea :=01 TO nLinsPag

            @ nRowLin,nMargen PRINT aLineas[ nLinNew ] ;
            FONT "Courier New" SIZE 09 
               
            IF( nLinNew ==nLineas, nLinea :=nLinsPag,)
                    
            nRowLin +=04
            nLinNew +=01

         NEXT
         
      END PRINTPAGE
      
   NEXT
   
END PRINTDOC

RETURN(NIL)


