 /*
___PROGRAM FILE________________________________________________________________
    Platform    : Windows NT/2000/XP/VISTA
 Developed with :
                  MiniGUI + Harbour Win32 GUI library (HMG)
                  and Harbour Compiler;
                  Compiled and Linked with MinGW.

                  Thanks to "Le Roy" Roberto Lopez.

   File Name    : WinPrg.exe
      Author    : Mustafa Lpez
        Mail    : mustalopez@gmail.com
 Description    : Contructor's automatic Windows & Prg's

Date created    : 25/04/2009 & 11-02-2010

   Copyright    : (c) 2009-2010  by Musta Lpez

     License    : Freeware

Distribucin    : Para cualquier tipo de distribucin de este software, pngase en
                  contacto con el autor

Responsabilidad.: El autor no asume ninguna responsabilidad por daos y perjuicios,
................: directos o indirectos,
................: Que puedan derivarse de la utilizacin de este software.
................: Se permite el uso personal, ilimitado y sin restricciones
................: Este software se proporciona " como est "

Distribution ...: For any type of distribution of this software, please contact the
                  author
  Disclaimer....: The author assumes no liability for damages, direct or indirect,
................: which may result from the use of this software.
................: Personal use, unlimited and unrestricted, is allowed.
................: This software is provided "as is"
_______________________________________________________________________________

     Programa Corregido por Pierpaolo Martinello < 27-06-2009 > Corrected program by Pierpaolo Martinello
     
     Programa PrintPrg creado y adaptado para WinPrg por Lucho Miranda  Mail: ElSalnes@Telefonica.NET < 17-07-2009 >
     PrintPrg Program created and adapted for WinPrg by  Lucho Miranda  Mail: ElSalnes@Telefonica.NET < 17-07-2009 >


*/

#define __SYSDATA__

# include "minigui.ch"
# include "Dbstruct.ch"

# define CRLF CHR(13)+CHR(10) 

*--------------------------- TOOLTIP ----------------------------*
*--------- Rutina cedida  Por Marcos Antonio Gambeta ------------*
#define WM_USER             0x400
#define TTM_SETTITLE       (WM_USER + 32)
#define TTI_NONE                0
#define TTI_INFO                1
#define TTI_WARNING             2
#define TTI_ERROR               3
*----------------------------------------------------------------*

Function Main()

*---------------------------------*
SET PROCEDURE TO BASEEST
SET PROCEDURE TO BROWSIN6
SET PROCEDURE TO MIRAX
SET PROCEDURE TO PrintPrg   
SET PROCEDURE TO PROGRESS
SET PROCEDURE TO winprg36x
SET PROCEDURE TO winprg37x
SET PROCEDURE TO winprg38x
SET PROCEDURE TO winprg39x
SET PROCEDURE TO Winprg40x
*---------------------------------*  
     
   REQUEST DBFCDX , DBFFPT
   RDDSETDEFAULT( "DBFCDX" )

   REQUEST DBFNTX , DBFDBT
   RDDSETDEFAULT( "DBFNTX" )

SET CENTURY ON
SET DATE FRENCH
SET DELETED ON
SET ESCAPE ON
SET BROWSESYNC ON
SET NAVIGATION EXTENDED
SET LANGUAGE TO SPANISH

*-----------------------------------------------------*
  SET TOOLTIPSTYLE BALLOON
// this follow rows is required ONLY for HMG Minigui compatibility
#ifdef __MINGW32__
   Local a_TmpColor   := { 193, 224, 255}     
   SET TOOLTIPBACKCOLOR a_TmpColor
   SET TOOLTIPFORECOLOR {0,0,0 }
#endif
*--------------------------------------*

PUBLIC aProgram,aNombre, compil
PUBLIC aWin00,aWin01,aWin02,aWin03,aWin04,aWin05,aWin06 ,aWin07,aWin08,cContenido ,cFile, aCnTxcDx, aInTxcDx
PUBLIC aWinum01,aWinum02,aWinum03,aWinum04,aWinum05,aWinum06,aWinum07,aWinum08,aWinum09,aWinum10,aWinum11,aWinum12
Public cContenido,cFileD, cFile, cFilex, cFileF, cFileFx ,filax, fix, count, FICHERAAX ,newtxt,;
       cPrgFolder := GetCurrentFolder() 
PUBLIC aNom,aTip,aNum,aDec
*--------------------------------------*
PUBLIC aNom01,aTip01,aNum01,aDec01
PUBLIC aNom02,aTip02,aNum02,aDec02
PUBLIC aNom03,aTip03,aNum03,aDec03
PUBLIC aNom04,aTip04,aNum04,aDec04
PUBLIC aNom05,aTip05,aNum05,aDec05
PUBLIC aNom06,aTip06,aNum06,aDec06
PUBLIC aNom07,aTip07,aNum07,aDec07
PUBLIC aNom08,aTip08,aNum08,aDec08
PUBLIC aNom09,aTip09,aNum09,aDec09
PUBLIC aNom10,aTip10,aNum10,aDec10
PUBLIC aNom11,aTip11,aNum11,aDec11
PUBLIC aNom12,aTip12,aNum12,aDec12
*--------------------------------------*
PUBLIC aNom13,aTip13,aNum13,aDec13
PUBLIC aNom14,aTip14,aNum14,aDec14
PUBLIC aNom15,aTip15,aNum15,aDec15
PUBLIC aNom16,aTip16,aNum16,aDec16
PUBLIC aNom17,aTip17,aNum17,aDec17
PUBLIC aNom18,aTip18,aNum18,aDec18
PUBLIC aNom19,aTip19,aNum19,aDec19
PUBLIC aNom20,aTip20,aNum20,aDec20
PUBLIC aNom21,aTip21,aNum21,aDec21
PUBLIC aNom22,aTip22,aNum22,aDec22
PUBLIC aNom23,aTip23,aNum23,aDec23
PUBLIC aNom24,aTip24,aNum24,aDec24
*--------------------------------------*
PUBLIC Code, aFiN,aLaN,aBDate, aMoney,aNotix,aNomFich,aJustify,aHEADERS ,aFIELDS
PUBLIC CodeS, aFiNS,aLaNS,aBDateS,aMoneyS,aNotixS,aChecbo,aCaNTXCDX,aCIntxcdx

    DEFINE WINDOW Form_1 AT 0,0     ;
           width 800 height 600     ;
           title "WinPrg 3.04"      ;
           icon "Logo"              ;
           main  nosize  nomaximize

           ON KEY ESCAPE ACTION Form_1.Release

    DEFINE TAB SECTION AT 10,10   ;
          width 780 height 530    ;
          font "Arial" size 10     
         
      define page "&Welcome"

        define image image01
            row 57
            col 20
            picture "WinPrg"
            width  740   
            height 448  
        end image

        define frame frame_01
            row 30
            col 5
            width 768
            height 490
            caption "Welcome- Marhaba-Bienvenidos"
        end frame

      END page

*---------------------------------------------- Window Sin Base Datos ------------------------------*
     define page "&Win Sin Base Datos"
        

           @ 32, 215 LABEL title_002 VALUE "Window Sin Base de Datos" AUTOSIZE ;
                     FONT "Verdana" SIZE 17 BOLD ITALIC ;
                     FONTCOLOR BLACK TRANSPARENT

           @ 29, 214 LABEL title_002x VALUE "Window Sin Base de Datos" AUTOSIZE ;
                     FONT "Verdana" SIZE 17 BOLD ITALIC ;
                     FONTCOLOR { 151, 223, 255 } TRANSPARENT


        define frame frame_02
            row 65
            col 5
            width 768
            height 457
            caption "Window Sin Base de Datos"
        end frame

        define frame frame_02a
            row 100
            col 90
            width 610
            height 100
            caption "Titulo de Window"
         end frame

        define frame frame_02b
            row 225
            col 90
            width 610
            height 140
            caption "Tamao del Window"
         end frame


                      @ 130,138 LABEL Label_01 VALUE 'Indique Nombre del'
                      @ 130,250 LABEL Label_02 VALUE 'Programa'

                      @ 130,340 LABEL Label_03 VALUE 'Indique Nombre del'
                      @ 130,457 LABEL Label_04 VALUE 'Autor'

                      @ 130,520 LABEL Label_05 VALUE 'Indique Titulo para'
                      @ 130,628 LABEL Label_06 VALUE 'Ventana'


                      @ 160,138 TEXTBOX Texto_00 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 100 HEIGHT 18 ;
                      MAXLENGTH 10 ;
                      TOOLTIP 'Indique Nombre del Programa'

                      @ 160,340 TEXTBOX Texto_01 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 140 HEIGHT 18 ;
                      MAXLENGTH 30 ;
                      TOOLTIP 'Indique Nombre del Autor'

                      @ 160,520 TEXTBOX Texto_02 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 120 HEIGHT 18 ;
                      MAXLENGTH 25 ;
                      TOOLTIP 'Indique Ttulo para Ventana'

                      @ 255,150 CHECKBOX CheckBoxC_01 CAPTION "Win  600 x 400" WIDTH 100 HEIGHT 28 ;
                      TOOLTIP 'Window 600 x 400'
                      @ 255,345 CHECKBOX CheckBoxC_02 CAPTION "Win  800 x 600" WIDTH 100 HEIGHT 28 ;
                      TOOLTIP 'Window 800 x 600'
                      @ 255,520 CHECKBOX CheckBoxC_03 CAPTION "Win 1100 x 800" WIDTH 100 HEIGHT 28 ;
                      TOOLTIP 'Windows 1100 x 800'

                      @ 285,150 CHECKBOX CheckBoxC_04 CAPTION "Main-Modal" WIDTH 100 HEIGHT 28 ;
                      TOOLTIP 'Win Main o Modal?'
                      @ 285,345 CHECKBOX CheckBoxC_05 CAPTION "Maximize ?" WIDTH 100 HEIGHT 28 ;
                      TOOLTIP 'Win Maximize o Nomaximize'
                      @ 285,520 CHECKBOX CheckBoxC_06 CAPTION "Botones ?"  WIDTH 100 HEIGHT 28 ;
                      TOOLTIP 'Win Con Botones'

                      @ 315,345 CHECKBOX CheckBoxC_07 CAPTION "Menu ?" WIDTH 100 HEIGHT 28 ;
                      TOOLTIP 'Win Con Menu'
            *-------------------------------  Botones  --------------------------*

                 @ 440,200  BUTTON Busc1           ;    
                       CAPTION 'Generar Fichero'   ;
                       PICTURE 'Bmp\Rueda.Bmp'     ;   
                       FONT "Arial" SIZE 9 BOLD ITALIC  ;
                       TOOLTIP 'Genera Fichero Prg';
                       WIDTH 105 HEIGHT 53         ;   
                       ACTION sinficherox()                                              
                        
                 @ 440,480 BUTTON Busc2            ;
                       CAPTION 'Salir'             ;   
                       PICTURE 'Bmp\Exit.Bmp'      ;   
                       FONT "Arial" SIZE 9 BOLD ITALIC  ;
                       TOOLTIP 'Finalizar'         ;
                       WIDTH 105 HEIGHT 53         ;   
                       ACTION FinalProgram()

  end page
*-------------------------------------------  Window Con Base Datos (6 Campos ) --------------------------*

    define page "&Win Con Base Datos [ 1 ]"


           @ 32, 210 LABEL title_003  VALUE "Window Con Base de Datos" AUTOSIZE ;
                     FONT "Verdana" SIZE 17 BOLD ITALIC ;
                     FONTCOLOR BLACK TRANSPARENT

           @ 29, 209 LABEL title_003x VALUE "Window Con Base de Datos" AUTOSIZE ;
                     FONT "Verdana" SIZE 17 BOLD ITALIC ;
                     FONTCOLOR { 151, 223, 255 } TRANSPARENT
 

      define frame frame_03
            row 65
            col 5
            width 768
            height 457
            caption "Window Con Base de Datos" 
       end frame

       define frame frame_03a
            row 85
            col 90
            width 615
            height 153
            caption "Titulo de Window - Complementos"
       end frame

       define frame frame_03b
            row 245
            col 90
            width 618
            height 257
            caption "Base de Datos"
       end frame

*-----------------------------------------------------------------------------------------*

                      @ 106,138 LABEL Label_01a VALUE 'Indique Nombre del'
                      @ 106,250 LABEL Label_02a VALUE 'Programa'

                      @ 106,340 LABEL Label_03a VALUE 'Indique Nombre del'
                      @ 106,457 LABEL Label_04a VALUE 'Autor'

                      @ 106,520 LABEL Label_05a VALUE 'Indique Titulo para'
                      @ 106,628 LABEL Label_06a VALUE 'Ventana'

                      @ 139,138 TEXTBOX Texto_00a ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 100 HEIGHT 18 ;
                      MAXLENGTH 10 ;
                      TOOLTIP 'Indique Nombre del Programa'

                      @ 139,340 TEXTBOX Texto_01a ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 140 HEIGHT 18 ;
                      MAXLENGTH 30 ;
                      TOOLTIP 'Indique Nombre del Autor'

                      @ 139,520 TEXTBOX Texto_02a ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 120 HEIGHT 18 ;
                      MAXLENGTH 25 ;
                      TOOLTIP 'Indique Ttulo para Ventana'

                      @ 170,150 CHECKBOX CheckBoxC_01a CAPTION "Win  600 x 400" WIDTH 100 HEIGHT 28 ;
                      TOOLTIP 'Window 600 x 400'
                      @ 170,345 CHECKBOX CheckBoxC_02a CAPTION "Win  800 x 600" WIDTH 100 HEIGHT 28 ;
                      TOOLTIP 'Window 800 x 600'
                      @ 170,520 CHECKBOX CheckBoxC_03a CAPTION "Win 1100 x 800" WIDTH 100 HEIGHT 28 ;
                      TOOLTIP 'Windows 1100 x 800'

                      @ 200,150 CHECKBOX CheckBoxC_04a CAPTION "Main-Modal" WIDTH 100 HEIGHT 28 ;
                      TOOLTIP 'Win Main o Modal?'
                      @ 200,345 CHECKBOX CheckBoxC_05a CAPTION "Maximize ?" WIDTH 100 HEIGHT 28 ;
                      TOOLTIP 'Win Maximize o Nomaximize'

                      @ 268,260 LABEL Label_07a VALUE 'Indique Nombre para Fichero, sin extensin  DBF' ;
                                   height 28 width 500

                      @ 319,260 LABEL Label_010a VALUE 'Indique los 6 Campos Para Generar el Browse' ;
                                   height 28 width 500

                      @ 293,348 TEXTBOX Texx_00a ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 90 HEIGHT 19 ;
                      TOOLTIP 'Indique Fichero sin extensin' ;
                      INPUTMASK "!!!!!!!!!"

                      @ 342,348 TEXTBOX Texx_01a ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                      @ 362,348 TEXTBOX Texx_02a ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                      @ 382,348 TEXTBOX Texx_03a ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                      @ 402,348 TEXTBOX Texx_04a ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                      @ 422,348 TEXTBOX Texx_05a ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                      @ 442,348 TEXTBOX Texx_06a ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                      @ 464,286 CHECKBOX CheckBoxx_1a CAPTION "Fichero Index ?" WIDTH 100 HEIGHT 28 ;
                      TOOLTIP 'Fichero Indexado ?'

                      @ 464,424 CHECKBOX CheckBoxx_2b CAPTION "Index NTX-CDX" WIDTH 100 HEIGHT 28 ;
                      TOOLTIP 'Indexar por NTX-CDX ?'

  
                     @ 413,135 BUTTON Busc1a0       ; 
                        CAPTION 'Generar Fichero'   ;
                        PICTURE 'Bmp\Rueda.Bmp'     ;   
                        FONT "Arial" SIZE 9 BOLD ITALIC  ;
                        TOOLTIP 'Con Base Datos de 6 Campos';
                        WIDTH 105 HEIGHT 53         ;   
                        ACTION ConFicherox()
                                             
                        
                     @ 413,524 BUTTON Busc1a1       ;
                       CAPTION 'Salir'              ;   
                       PICTURE 'Bmp\Exit.Bmp'       ;   
                       FONT "Arial" SIZE 9 BOLD ITALIC  ;
                       TOOLTIP 'Finalizar'          ;
                       WIDTH 105 HEIGHT 53          ;   
                       ACTION FinalProgram()
                                     

    end page

*-------------------------------------------  Window Con Base Datos [2]-------------------------------------*

    define page "&Win Con Base Datos [ 2 ]"

         
           @ 32, 210 LABEL title_0032  VALUE "Window Con Base de Datos" AUTOSIZE ;
                     FONT "Verdana" SIZE 17 BOLD ITALIC ;
                     FONTCOLOR BLACK TRANSPARENT

           @ 29, 209 LABEL title_003x2 VALUE "Window Con Base de Datos" AUTOSIZE ;
                     FONT "Verdana" SIZE 17 BOLD ITALIC ;
                     FONTCOLOR { 151, 223, 255 } TRANSPARENT


      define frame frame_032
            row 65
            col 5
            width 768
            height 457
            caption "Window Con Base de Datos" 
       end frame

       define frame frame_03a2
            row 85
            col 90
            width 615
            height 153
            caption "Titulo de Window - Complementos"
       end frame

       define frame frame_03b2
            row 245
            col 90
            width 618
            height 257
            caption "Base de Datos"
       end frame

*-----------------------------------------------------------------------------------------*

                      @ 106,138 LABEL Label_01a2 VALUE 'Indique Nombre del'
                      @ 106,250 LABEL Label_02a2 VALUE 'Programa'

                      @ 106,340 LABEL Label_03a2 VALUE 'Indique Nombre del'
                      @ 106,457 LABEL Label_04a2 VALUE 'Autor'

                      @ 106,520 LABEL Label_05a2 VALUE 'Indique Titulo para'
                      @ 106,628 LABEL Label_06a2 VALUE 'Ventana'

                      @ 139,138 TEXTBOX Texto_00a2 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 100 HEIGHT 18 ;
                      MAXLENGTH 10 ;
                      TOOLTIP 'Indique Nombre del Programa'

                      @ 139,340 TEXTBOX Texto_01a2 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 140 HEIGHT 18 ;
                      MAXLENGTH 30 ;
                      TOOLTIP 'Indique Nombre del Autor'

                      @ 139,520 TEXTBOX Texto_02a2 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 120 HEIGHT 18 ;
                      MAXLENGTH 25 ;
                      TOOLTIP 'Indique Ttulo para Ventana'

                      @ 170,150 CHECKBOX CheckBoxC_01a2 CAPTION "Win 600 x 400" WIDTH 100 HEIGHT 28 ;
                      TOOLTIP 'Window 600 x 400'
                      @ 170,345 CHECKBOX CheckBoxC_02a2 CAPTION "Win 800 x 600" WIDTH 100 HEIGHT 28 ;
                      TOOLTIP 'Window 800 x 600'
                      @ 170,520 CHECKBOX CheckBoxC_03a2 CAPTION "Win 1100 x 800" WIDTH 100 HEIGHT 28 ;
                      TOOLTIP 'Windows 1100 x 800'

                      @ 200,150 CHECKBOX CheckBoxC_04a2 CAPTION "Main-Modal" WIDTH 100 HEIGHT 28 ;
                      TOOLTIP 'Win Main o Modal?'
                      @ 200,345 CHECKBOX CheckBoxC_05a2 CAPTION "Maximize ?" WIDTH 100 HEIGHT 28 ;
                      TOOLTIP 'Win Maximize o Nomaximize'

                      @ 200,520 CHECKBOX CheckBoxC_06a2 CAPTION "Numeric " WIDTH 100 HEIGHT 28 ;
                      TOOLTIP 'Numeric Moneda '

                      @ 268,260 LABEL Label_07a2 VALUE 'Indique Nombre para Fichero, sin extensin  DBF' ;
                                   height 28 width 500                           

                      @ 293,348 TEXTBOX Texx_00a2 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 90 HEIGHT 19 ;
                      TOOLTIP 'Indique Fichero sin extensin' ;
                      INPUTMASK "!!!!!!!!!"
                      
                      @ 330,262 LABEL Labelx_1z2 VALUE 'Indique Fichero Ind'
                      @ 330,368 LABEL Labelx_2z2 VALUE 'exado ?   Indexado '
                      @ 330,480 LABEL Labelx_3z2 VALUE 'por -> NTX -  CDX'

                      @ 360,348 CHECKBOX CheckBoxx_1a2 CAPTION "Fichero Index ?" WIDTH 100 HEIGHT 28 ;
                        TOOLTIP 'Fichero Indexado ?'

                      @ 410,348 CHECKBOX CheckBoxx_2b2 CAPTION "Index NTX-CDX ?" WIDTH 100 HEIGHT 28 ;
                        TOOLTIP 'Indexado por -> NTX-CDX ?'


                       
                     
                      @ 370,135 BUTTON Busc2a        ;
                        CAPTION 'Generar con Base'   ;
                        PICTURE 'Bmp\Base.Bmp'       ;   
                        FONT "Arial" SIZE 9 BOLD ITALIC    ;
                        TOOLTIP 'Con Toda la Base de Datos';
                        WIDTH 130 HEIGHT 53          ;   
                        ACTION ConFicheroxxx()

                                             

                     @ 370,528 BUTTON Busc3a         ;
                        CAPTION 'Generar con Menu'   ;
                        PICTURE 'Bmp\Menu.Bmp'       ;   
                        FONT "Arial" SIZE 9 BOLD ITALIC  ;
                        TOOLTIP 'Con Toda la Base de Datos y Menu';
                        WIDTH 130 HEIGHT 53          ;   
                        ACTION ConFicheroxx()


                     @ 433,135 BUTTON Busc4a         ;
                        CAPTION 'Generar con Botones';
                        PICTURE 'Bmp\Boton.Bmp'      ;   
                        FONT "Arial" SIZE 9 BOLD ITALIC  ;
                        TOOLTIP 'Con Toda la Base de Datos y Botones';
                        WIDTH 130 HEIGHT 53          ;   
                        ACTION ConFicheroxxxx()

                       
                     @ 433,528 BUTTON Busc5a         ;
                       CAPTION 'Salir'               ;   
                       PICTURE 'Bmp\Exit.Bmp'        ;   
                       FONT "Arial" SIZE 9 BOLD ITALIC  ;
                       TOOLTIP 'Finalizar'           ;
                       WIDTH 130 HEIGHT 53           ;   
                       ACTION FinalProgram()

    end page


*------------------------------------------------  Crear Bases de Datos --------------------------------*

    define page "&Crear Bases de Datos"

        define frame frame_04
            row 30
            col 5
            width 768
            height 490
            caption "Crear Base de Datos"
        end frame

          
           @ 41, 273 LABEL title_004  VALUE "Crear Base de Datos" AUTOSIZE ;
                     FONT "Verdana" SIZE 17 BOLD ITALIC ;
                     FONTCOLOR BLACK TRANSPARENT

           @ 38, 272 LABEL title_004x VALUE "Crear Base de Datos" AUTOSIZE ;
                     FONT "Verdana" SIZE 17 BOLD ITALIC ;
                     FONTCOLOR { 151, 223, 255 } TRANSPARENT


*---------------------------------------------------------------------------------------*
                    @ 74,260 LABEL Label_1 VALUE 'Indique Nombre para'
                    @ 74,380 LABEL Label_2 VALUE 'Fichero, sin extensin'
                    @ 74,503 LABEL Label_3 VALUE ' DBF'

                    @ 102,350 TEXTBOX Tex_00 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 90 HEIGHT 18 ;
                      TOOLTIP 'Fichero a Crear sin extensin' ;
                      INPUTMASK "!!!!!!!!!"

                   *---------------------------------------------------------------*

                     @ 128,220 LABEL Label_4 VALUE 'Nombre - Tipo ->'

                     @ 128,319 LABEL Label_7 VALUE '[ Tipo = C N D L M ]'

                     @ 128,430 LABEL Label_5 VALUE '- Longitud -'

                     @ 128,495 LABEL Label_6 VALUE 'Decimales'

                     @ 146,220 LABEL Label_8 VALUE 'Ejemplo:  Nombre ,'
                     @ 146,328 LABEL Label_9 VALUE 'C,  25,  0'

                *---------------------------------------------------------------------*
                      @ 168,220 TEXTBOX Tex_01 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                      @ 168,313 TEXTBOX Tex_02 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                      INPUTMASK "!"

                      @ 168,335 TEXTBOX Tex_03 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                      @ 168,376 TEXTBOX Tex_04 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2
                 *--------------------------------------------------------*
                      @ 188,220 TEXTBOX Tex_05 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                      @ 188,313 TEXTBOX Tex_06 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                      INPUTMASK "!"

                      @ 188,335 TEXTBOX Tex_07 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                      @ 188,376 TEXTBOX Tex_08 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2
                *--------------------------------------------------------*
                      @ 208,220 TEXTBOX Tex_09 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                      @ 208,313 TEXTBOX Tex_10 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                      INPUTMASK "!"

                      @ 208,335 TEXTBOX Tex_11 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                      @ 208,376 TEXTBOX Tex_12 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2

               *--------------------------------------------------------*
                     @ 228,220 TEXTBOX Tex_13 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                      @ 228,313 TEXTBOX Tex_14 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                       INPUTMASK "!"

                      @ 228,335 TEXTBOX Tex_15 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                     @ 228,376 TEXTBOX Tex_16 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2
              *--------------------------------------------------------*
                     @ 248,220 TEXTBOX Tex_17 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                      @ 248,313 TEXTBOX Tex_18 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                      INPUTMASK "!"

                      @ 248,335 TEXTBOX Tex_19 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                      @ 248,376 TEXTBOX Tex_20 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2
              *--------------------------------------------------------*
                     @ 268,220 TEXTBOX Tex_21 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                      @ 268,313 TEXTBOX Tex_22 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                      INPUTMASK "!"

                      @ 268,335 TEXTBOX Tex_23 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                     @ 268,376 TEXTBOX Tex_24 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2
              *--------------------------------------------------------*
                     @ 288,220 TEXTBOX Tex_25 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                      @ 288,313 TEXTBOX Tex_26 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                      INPUTMASK "!"

                      @ 288,335 TEXTBOX Tex_27 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                      @ 288,376 TEXTBOX Tex_28 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2
             *--------------------------------------------------------*
                     @ 308,220 TEXTBOX Tex_29 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                      @ 308,313 TEXTBOX Tex_30 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                      INPUTMASK "!"

                      @ 308,335 TEXTBOX Tex_31 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                     @ 308,376 TEXTBOX Tex_32 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2
             *--------------------------------------------------------*
                     @ 328,220 TEXTBOX Tex_33 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                     @ 328,313 TEXTBOX Tex_34 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                      INPUTMASK "!"

                     @ 328,335 TEXTBOX Tex_35 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                     @ 328,376 TEXTBOX Tex_36 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2
              *--------------------------------------------------------*
                     @ 348,220 TEXTBOX Tex_37 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                      @ 348,313 TEXTBOX Tex_38 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                      INPUTMASK "!"

                      @ 348,335 TEXTBOX Tex_39 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                     @ 348,376 TEXTBOX Tex_40 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2
             *----------------------------------------------------------*
                      @ 368,220 TEXTBOX Tex_41 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                      @ 368,313 TEXTBOX Tex_42 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                      INPUTMASK "!"

                      @ 368,335 TEXTBOX Tex_43 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                     @ 368,376 TEXTBOX Tex_44 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2
           *-------------------------------------------------------------*
                     @ 388,220 TEXTBOX Tex_45 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                      @ 388,313 TEXTBOX Tex_46 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                      INPUTMASK "!"

                      @ 388,335 TEXTBOX Tex_47;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                     @ 388,376 TEXTBOX Tex_48 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2
            *---X-------------------- Segunda Columna -----------------X--*
                     @ 168,410 TEXTBOX Tex_49 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                      @ 168,503 TEXTBOX Tex_50 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                      INPUTMASK "!"

                     @ 168,525 TEXTBOX Tex_51 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                     @ 168,566 TEXTBOX Tex_52 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2
             *-------------------------------------------------------------*
                     @ 188,410 TEXTBOX Tex_53 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                     @ 187,503 TEXTBOX Tex_54 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                      INPUTMASK "!"

                     @ 188,525 TEXTBOX Tex_55 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                     @ 188,566 TEXTBOX Tex_56 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2
             *-------------------------------------------------------------*
                     @ 208,410 TEXTBOX Tex_57 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                     @ 208,503 TEXTBOX Tex_58 ;
                     VALUE "" ;
                     BACKCOLOR {183,214,255}  ;
                      WIDTH 15 HEIGHT 18 ;
                     INPUTMASK "!"

                     @ 208,525 TEXTBOX Tex_59 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                     @ 208,566 TEXTBOX Tex_60 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2
               *-------------------------------------------------------------*
                     @ 228,410 TEXTBOX Tex_61 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                     @ 228,503 TEXTBOX Tex_62 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                      INPUTMASK "!"

                     @ 228,525 TEXTBOX Tex_63 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                     @ 228,566 TEXTBOX Tex_64 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2
             *-------------------------------------------------------------*
                     @ 248,410 TEXTBOX Tex_65 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                     @ 248,503 TEXTBOX Tex_66 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                      INPUTMASK "!"

                     @ 248,525 TEXTBOX Tex_67 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                     @ 248,566 TEXTBOX Tex_68 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2
                *------------------------------------------*
                     @ 268,410 TEXTBOX Tex_69 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                     @ 268,503 TEXTBOX Tex_70 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                      INPUTMASK "!"

                     @ 268,525 TEXTBOX Tex_71 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                     @ 268,566 TEXTBOX Tex_72 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2
                 *---------------------------------------*
                     @ 288,410 TEXTBOX Tex_73 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                     @ 288,503 TEXTBOX Tex_74 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                      INPUTMASK "!"

                     @ 288,525 TEXTBOX Tex_75 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                     @ 288,566 TEXTBOX Tex_76 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2
              *-------------------------------------------------------------*
                     @ 308,410 TEXTBOX Tex_77 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                     @ 308,503 TEXTBOX Tex_78 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                      INPUTMASK "!"

                     @ 308,525 TEXTBOX Tex_79 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                     @ 308,566 TEXTBOX Tex_80 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2
                *-------------------------------------------------------------*
                     @ 328,410 TEXTBOX Tex_81 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                     @ 328,503 TEXTBOX Tex_82 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                      INPUTMASK "!"

                     @ 328,525 TEXTBOX Tex_83 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                     @ 328,566 TEXTBOX Tex_84 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2
               *--------------------------------------*
                     @ 348,410 TEXTBOX Tex_85 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                     @ 348,503 TEXTBOX Tex_86 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                      INPUTMASK "!"

                     @ 348,525 TEXTBOX Tex_87 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                     @ 348,566 TEXTBOX Tex_88 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2
               *--------------------------------------*
                     @ 368,410 TEXTBOX Tex_89 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                     @ 368,503 TEXTBOX Tex_90 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                      INPUTMASK "!"

                     @ 368,525 TEXTBOX Tex_91 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                     @ 368,566 TEXTBOX Tex_92 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2
               *--------------------------------------*
                     @ 388,410 TEXTBOX Tex_93 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 86 HEIGHT 18 ;
                      MAXLENGTH 10

                     @ 388,503 TEXTBOX Tex_94 ;
                      VALUE "" ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 15 HEIGHT 18 ;
                      INPUTMASK "!"

                     @ 388,525 TEXTBOX Tex_95 ;
                      NUMERIC ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 35 HEIGHT 18 ;
                      MAXLENGTH 3

                     @ 388,566 TEXTBOX Tex_96 ;
                      NUMERIC  ;
                      BACKCOLOR {183,214,255} ;
                      WIDTH 20 HEIGHT 18 ;
                      MAXLENGTH 2

            *--------------- indexar -----------------*

                      @ 425,281 LABEL Labelx_1I VALUE 'Indique Nmero '
                      @ 425,375 LABEL Labelx_2I VALUE 'Campo indexar'

                      @ 425,489 TEXTBOX Tex_97 ;
                       NUMERIC  ;
                       BACKCOLOR {183,214,255} ;
                       WIDTH 20 HEIGHT 18 ;
                       MAXLENGTH 2  ;
                       TOOLTIP 'Campo Index -> 1 al 24 <-'


               @ 445,348 CHECKBOX CheckBoxx_aa CAPTION "Index NTX-CDX ?" WIDTH 100 HEIGHT 28 ;
                     TOOLTIP 'Indexar fichero con NTX-CDX ?'


               @ 470,348 CHECKBOX CheckBoxx_bb CAPTION "Fiche DBT-FPT ?" WIDTH 100 HEIGHT 28 ;
                     TOOLTIP 'Fichero con Campo MEMO?'

            *------------------------------------------*
 
                                
                 @ 455,140 BUTTON Buscar1        ;    
                       CAPTION 'Graba Fichero'   ;
                       PICTURE 'Bmp\Grabar.Bmp'  ;   
                       FONT "Arial" SIZE 9 BOLD ITALIC  ;
                       TOOLTIP 'Graba Nuevo Fichero DBF';
                       WIDTH 105 HEIGHT 53       ;   
                       ACTION createtables()  

                        
                 @ 455,564 BUTTON Buscar2        ;    
                       CAPTION 'Salir'           ;
                       PICTURE 'Bmp\Exit.Bmp'    ;   
                       FONT "Arial" SIZE 9 BOLD ITALIC  ;
                       TOOLTIP 'Finalizar'       ;
                       WIDTH 105 HEIGHT 53       ;   
                       ACTION FinalProgram()

      END page
*----------------------------------------- Ver Base de Datos ------------------------*
      define page "&Ver Base Datos"

         define frame   frame_05
             row 30
             col 5
             width 768
             height 490
             caption "Ver Base de Datos"
         end frame
         
           @ 51, 275 LABEL title_005  VALUE "Ver Base de Datos" AUTOSIZE ;
                     FONT "Verdana" SIZE 17 BOLD ITALIC ;
                     FONTCOLOR BLACK TRANSPARENT

           @ 48, 274 LABEL title_005x VALUE "Ver Base de Datos" AUTOSIZE ;
                     FONT "Verdana" SIZE 17 BOLD ITALIC ;
                     FONTCOLOR { 151, 223, 255 } TRANSPARENT

                    @ 95,262 LABEL Labelx_1 VALUE 'Indique Nombre para'
                    @ 95,382 LABEL Labelx_2 VALUE 'Fichero, sin extensin'
                    @ 95,505 LABEL Labelx_3 VALUE ' DBF'

*----------------------------------------------------------------------------*
                    @ 143,348 TEXTBOX Texx_00 ;
                    VALUE "" ;
                    BACKCOLOR {183,214,255} ;
                    WIDTH 90 HEIGHT 18 ;
                    TOOLTIP 'Fichero a Visualizar sin extensin'      ;
                    INPUTMASK "!!!!!!!!!"
*----------------------------------------------------------------------------*

                    @ 190,262 LABEL Labelx_1z VALUE 'Indique Fichero Ind'
                    @ 190,368 LABEL Labelx_2z VALUE 'exado ?   Indexado '
                    @ 190,480 LABEL Labelx_3z VALUE 'por -> NTX -  CDX'

                    @ 240,348 CHECKBOX CheckBoxx_1 CAPTION "Fichero Index ?" WIDTH 100 HEIGHT 28 ;
                      TOOLTIP 'Fichero Indexado ?'

                    @ 290,348 CHECKBOX CheckBoxx_2 CAPTION "Index NTX-CDX ?" WIDTH 100 HEIGHT 28 ;
                      TOOLTIP 'Indexado por -> NTX-CDX ?'
                 
                               
                 @ 335,340 BUTTON Busx0           ;    
                       CAPTION 'Elegir Fichero'   ;
                       PICTURE 'Bmp\Search.Bmp'   ;           
                       FONT "Arial" SIZE 9 BOLD ITALIC  ;
                       TOOLTIP 'Elegir Fichero'   ;
                       WIDTH 105 HEIGHT 53        ;   
                       ACTION  MIRAX()    

                        
                 @ 400,200 BUTTON Busx1           ;    
                       CAPTION 'Ver Browse'       ;
                       PICTURE 'Bmp\SearchX.Bmp'  ;                       
                       FONT "Arial" SIZE 9 BOLD ITALIC  ;
                       TOOLTIP 'Ver Fichero DbF'  ;
                       WIDTH 105 HEIGHT 53        ;   
                       ACTION VerBrowse() 

                              
                 @ 400,340 BUTTON Busx2           ;    
                       CAPTION 'Ver Estructura'   ;
                       PICTURE 'Bmp\StructurX.Bmp';                 
                       FONT "Arial" SIZE 9 BOLD ITALIC  ;
                       TOOLTIP 'Ver Estructura Fichero';
                       WIDTH 105 HEIGHT 53        ;   
                       ACTION  CrearEstructura()

                           
                 @ 400,485 BUTTON Busx3           ; 
                       CAPTION 'Salir'            ;
                       PICTURE 'Bmp\Exit.Bmp'     ;   
                       FONT "Arial" SIZE 9 BOLD ITALIC  ;
                       TOOLTIP 'Finalizar'        ;
                       WIDTH 105 HEIGHT 53        ;   
                       ACTION FinalProgram()    


     end page

*--------------------------------------------  Editor PRG    -----------------------------*

     define page "&Editor_Prg"

        define frame frame_06
            row 30
            col 5
            width 768
            height 490
            caption "Editor Codigo Fuente Prg"
        end frame


                  IF .NOT. FILE ("memuar1.mem")
                       FICHERAAX := "No_Se_Grab.Prg"
                       SAVE TO memuar1 ALL LIKE  FICHERAAX                  
                  ENDIF 

                  RESTORE FROM MEMUAR1 ADDITIVE   

                  IF FICHERAAX = ".prg"
                     FICHERAAX := "No_Se_Eligi.Prg"
                     SAVE TO memuar1 ALL LIKE  FICHERAAX
                     RESTORE FROM MEMUAR1 ADDITIVE   
                  ENDIF      

*----------------------------Visor ltimo fichero guardado obcion Label o Texbox -----------*
 
            *    @ 054,646 LABEL Label_3F VALUE SPACE(2) + ALLTRIM( FICHERAAX) + SPACE(1) ;                    
            *               BACKCOLOR {128,175,174}   FONTCOLOR {255,255,000}                                      
                
                 @ 059,640 TEXTBOX Tex_0V         ;       
                       VALUE ALLTRIM( FICHERAAX)  ;
                       BACKCOLOR {128,175,174}    ;  
                       FONTCOLOR {255,255,000}    ;   
                       WIDTH 125 HEIGHT 18        ;
                       MAXLENGTH 8                ;
                       TOOLTIP 'ltimo Fichero Guardado'

                       Form_1.Tex_0V.ReadOnly := .T. 

 *----------------------------------------  FRAME Adorno Cuadro -----------------------------------------------*
        @ 059,015 FRAME Frame_03H WIDTH 614 HEIGHT 445 CAPTION "Editor - Lector: "                                 
 *-------------------------------------------------------------------------------------------------------------*

                @ 090,672 TEXTBOX Tex_1P       ;       // aqui entro el nombre del nuevo fichero.Prg    
                       VALUE ""                ;
                       BACKCOLOR {183,214,255} ;
                       WIDTH 70 HEIGHT 18      ;
                       MAXLENGTH 8             ;
                       TOOLTIP 'Fichero a Crear sin extensin'

                  DEFINE BUTTON Buscar1H               // aqui grabo el fichero creado por el TEXTBOX 
                      ROW    119
                      COL    640
                      WIDTH  125    
                      HEIGHT 028
                      ACTION SalvaFichero()     
                      CAPTION "Graba Nombre"
                      FONTNAME "Arial"
                      FONTSIZE 8
                      TOOLTIP "Graba Nombre Fichero Prg"
                      FONTBOLD .T.
                      FONTITALIC .T.
                      FONTUNDERLINE .F.
                      FONTSTRIKEOUT .F.
                      ONGOTFOCUS Nil
                      ONLOSTFOCUS Nil
                      HELPID Nil
                      FLAT .F.
                      TABSTOP .T.
                      VISIBLE .T.
                      TRANSPARENT .F.
                      MULTILINE .F.
                      PICTURE "Bmp\Grabar.Bmp"
                      PICTALIGNMENT LEFT
                  END BUTTON
*----------------------------------------------------------------------------------------------------------------*

                @ 155,650 BUTTON Buscar2H      ;     // aqui limpio editor
                       CAPTION 'Nuevo Prg'     ;
                       PICTURE 'Bmp\NewX.Bmp'  ;   
                       FONT "Arial" SIZE 9 BOLD ITALIC ; 
                       TOOLTIP 'Redactar Prg'  ;
                       WIDTH 105 HEIGHT 53     ;    
                       ACTION Limpia()            
             
                 @ 215,650 BUTTON Buscar3H     ;    // aqui busco el fichero para  que suba al EDITBOX
                       CAPTION 'Buscar Prg'    ;
                       PICTURE 'Bmp\Search.Bmp';   
                       FONT "Arial" SIZE 9 BOLD ITALIC ;
                       TOOLTIP 'Busca Fichero Prg'     ;
                       WIDTH 105 HEIGHT 53     ;   
                       ACTION BuscaFichero()    
                 
                 @ 275,650 BUTTON Buscar4H     ;   // aqui grabo lo que he escrito como Texto 
                       CAPTION 'Graba Prg'     ;
                       PICTURE 'Bmp\Grabar.Bmp';   
                       FONT "Arial" SIZE 9 BOLD ITALIC ;
                       TOOLTIP 'Grabar Fichero Prg';
                       WIDTH 105 HEIGHT 53     ;                          
                       ACTION TextoGraba()        
                  
                 @ 335,650 BUTTON Buscar5H     ;    // aqui imprimir Prg
                       CAPTION 'Imprimir Prg'  ;
                       PICTURE 'Bmp\Print.Bmp' ;   
                       FONT "Arial" SIZE 9 BOLD ITALIC ; 
                       TOOLTIP 'Imprimir Prg'  ; 
                       WIDTH 105 HEIGHT 53     ;   
                       ACTION PrintFilesPRG()    
          
                 @ 395,650 BUTTON Buscar6H     ;  // aqui Borro Prg
                       CAPTION 'Borrar Prg'    ;
                       PICTURE 'Bmp\Erase.Bmp' ;   
                       FONT "Arial" SIZE 9 BOLD ITALIC ; 
                       TOOLTIP 'Borrar Fichero Prg' ; 
                       WIDTH 105 HEIGHT 53     ;         
                       ACTION Borrax()
 

                 @ 455,650 BUTTON SalirH       ;
                       CAPTION 'Salir'         ;
                       PICTURE 'Bmp\Exit.Bmp'  ;   
                       FONT "Arial" SIZE 9 BOLD ITALIC ; 
                       TOOLTIP 'Salir del Editor'      ;
                       WIDTH 105 HEIGHT 53     ;    
                       ACTION FinalProgram()  


                  
                   DEFINE EDITBOX Edit_1P
                          ROW 83
                          COL 25
                          WIDTH 595
                          HEIGHT 387
                          BACKCOLOR {183,214,255}
                          VALUE cContenido
                          ON CHANGE ShowRowCol()                  
                          FONTNAME "Arial"         
                          FONTSIZE 10
                          FONTBOLD .T.
                          FONTITALIC .T.
                          TOOLTIP 'Escriba Texto y Grabelo'                              
                   END EDITBOX

        
    @ Form_1.Edit_1P.Row + Form_1.Edit_1P.Height + 11, ;   //  20  12    
      Form_1.Edit_1P.Col  ;                                     
             LABEL L_1 ;
             VALUE "" ;           //    BACKCOLOR {128,175,174}  ; FONTCOLOR {255,255,000} ;            
             FONTCOLOR {0,64,128} ;          
             AUTOSIZE           


      end page

*----------------------------------------------- Compilar Ayuda - Help  --------------------------------*

      define page "&Compilar_Help"

          define frame frame_07
            row 30
            col 5
            width 768
            height 490
            caption "Welcome- Marhaba-Bienvenidos"
         end frame

         define frame frame_07a
            row 90
            col 90
            width 615
            height 160
            caption "Compilar Prg"
         end frame

         define frame frame_07b
            row 260
            col 90
            width 618
            height 200
            caption "Ayuda - Help "
         end frame

  
               @ 049,275 LABEL title_006a  VALUE "Compilar Fichero Prg" AUTOSIZE ;
                     FONT "Verdana" SIZE 17 BOLD ITALIC ;
                     FONTCOLOR BLACK TRANSPARENT

               @ 046,274 LABEL title_006b VALUE "Compilar Fichero Prg" AUTOSIZE ;
                     FONT "Verdana" SIZE 17 BOLD ITALIC ;
                     FONTCOLOR { 151, 223, 255 } TRANSPARENT


               @ 115,300 LABEL Label_1C VALUE 'Indique Nombre, sin'
               @ 115,412 LABEL Label_2C VALUE ' extensin PRG'


               @ 150,350 TEXTBOX Tex_1C ;
               VALUE "" ;
               BACKCOLOR {180,200,255} ;
               WIDTH 100 HEIGHT 18 ;
               MAXLENGTH 10 ;
               TOOLTIP 'Fichero Compilar sin extensin'

               aCompil := ALLTRIM(Form_1.Tex_1c.value)

               SAVE TO COMPILI ALL LIKE aCompil*

                                
                  @ 180,350 BUTTON salirR            ;   
                       CAPTION 'Compilar'            ;
                       PICTURE 'Bmp\Hmg.bmp'         ;   
                       FONT "Arial" SIZE 9 BOLD ITALIC  ;
                       TOOLTIP 'Compilar Fichero PRG';
                       WIDTH 105 HEIGHT 53           ;   
                       ACTION  PreCompila()


               @ 285,320 LABEL title_007a  VALUE "Ayuda - Help" AUTOSIZE ;
                     FONT "Verdana" SIZE 17 BOLD ITALIC ;
                     FONTCOLOR BLACK TRANSPARENT

               @ 282,319 LABEL title_007b VALUE "Ayuda - Help" AUTOSIZE ;
                     FONT "Verdana" SIZE 17 BOLD ITALIC ;
                     FONTCOLOR { 151, 223, 255 } TRANSPARENT

  
                                
                 @ 380,164 BUTTON Bustc3          ;    
                       CAPTION 'Ayuda'            ;
                       PICTURE 'Bmp\Salvavidas.Bmp'     ;   
                       FONT "Arial" SIZE 9 BOLD ITALIC  ;
                       TOOLTIP 'Ver Ayuda Espaol';
                       WIDTH 105 HEIGHT 53        ;   
                       ACTION aYudax()
                                  
                 @ 380,350 BUTTON Bustc3I         ;    
                       CAPTION 'Help'             ;
                       PICTURE 'Bmp\Salvavidas.Bmp'     ;   
                       FONT "Arial" SIZE 9 BOLD ITALIC  ;
                       TOOLTIP 'See Help English' ;
                       WIDTH 105 HEIGHT 53        ;   
                       ACTION aYudaxI ()

                        
                 @ 380,524  BUTTON Bustc4         ;    
                       CAPTION 'Salir'            ;
                       PICTURE 'Bmp\Exit.Bmp'     ;   
                       FONT "Arial" SIZE 9 BOLD ITALIC  ;
                       TOOLTIP 'Finalizar'        ;
                       WIDTH 105 HEIGHT 53        ;   
                       ACTION FinalProgram()

      end page

  *--------------------------------------------------   About -------------------------------------*

   define page "&About"

        define frame frame_09
            row 30
            col 5
            width 768
            height 490
            caption "Welcome- Marhaba-Bienvenidos"
        end frame

 *-------------------------------------------------------------------------*

 *-----------------------------  Box Raya ---------------------------------*
       @ 053,022 LABEL BOX_IN00 WIDTH 738 HEIGHT 453 ;
                    FONT "Ms Sans Serif" SIZE 0011 BOLD ITALIC BORDER  

                 Form_1.BOX_IN00.Enabled := .F.
 *-------------------------------------------------------------------------*   
 *------------------------------ Box Undido--------------------------------*
       @ 144,078 LABEL BOX_IN01 WIDTH 217 HEIGHT 297 ;
                    FONT "Ms Sans Serif" SIZE 0011 BORDER CLIENTEDGE         
                 Form_1.BOX_IN01.Enabled := .F.
 *-------------------------------------------------------------------------*   
 *------------------------------ Box Undido--------------------------------*
       @ 144,330 LABEL BOX_IN02 WIDTH 358 HEIGHT 297 ;   
                    FONT "Ms Sans Serif" SIZE 0011 BORDER CLIENTEDGE          
  
                 Form_1.BOX_IN02.Enabled := .F.
 *-------------------------------------------------------------------------*   

        define image image4
            row 159                   
            col 90
            picture "musta"
            width   190             
            height  270            
         end image
              
        define label Label_x0c
            row 078
            col 290
            fontname "Arial"
            fontsize 25
            transparent .t.
            value  "WinPrg  v 3.04" 
            height 110
            width 550
            fontcolor {026,052,107}
            FONTITALIC .T.
            FONTBOLD .T.
       end label

       define label Label_xpc
            row 075
            col 288
            fontname "Arial"
            fontsize 25
            transparent .t.
            value  "WinPrg  v 3.04" 
            height 110
            width 550
            fontcolor {151, 223, 255}
            FONTITALIC .T.
            FONTBOLD .T.
        end label

 @ 164,359 LABEL Label_x1c VALUE "Hola  Amigos  esta  es mi pequea contribucin." AUTOSIZE ;
                    FONT "Arial" SIZE 10 BOLD ITALIC ;
                    FONTCOLOR { 026, 052, 107 } TRANSPARENT

 @ 194,359 LABEL Label_x2c VALUE "Gracias  al  'Rey'  Roberto  Lpez , estamos hoy" AUTOSIZE ;
                    FONT "Arial" SIZE 10 BOLD ITALIC ;
                    FONTCOLOR { 026, 052, 107 } TRANSPARENT   

 @ 224,359 LABEL Label_x3c VALUE "los  usuarios  de  Clipper  con  una Herramienta" AUTOSIZE ;
                    FONT "Arial" SIZE 10 BOLD ITALIC ;
                    FONTCOLOR { 026, 052, 107 } TRANSPARENT            

 @ 254,359 LABEL Label_x4c VALUE "maravillosa  que   es   Harbour +  Minigui.    " AUTOSIZE ;
                    FONT "Arial" SIZE 10 BOLD ITALIC ;
                    FONTCOLOR { 026, 052, 107 } TRANSPARENT            

 @ 284,359 LABEL Label_x5c VALUE " Este   programa  es   para  los  que  empiezan" AUTOSIZE ;
                    FONT "Arial" SIZE 10 BOLD ITALIC ;
                    FONTCOLOR { 026, 052, 107 } TRANSPARENT            
         
 @ 314,359 LABEL Label_x6c VALUE "o  se  reciclan como  yo,  a  la nueva forma  de" AUTOSIZE ;
                    FONT "Arial" SIZE 10 BOLD ITALIC ;
                    FONTCOLOR { 026, 052, 107 } TRANSPARENT            
         
 @ 344,359 LABEL Label_x7c VALUE "trabajo.  Gracias  a todos, amigos, sin vosotros" AUTOSIZE ;
                    FONT "Arial" SIZE 10 BOLD ITALIC ;
                    FONTCOLOR { 026, 052, 107 } TRANSPARENT     
 

 @ 374,359 LABEL Label_x8c VALUE "no hubiera llegado , hasta aqu.  Mustafa Lpez " AUTOSIZE ;
                    FONT "Arial" SIZE 10 BOLD ITALIC ;
                    FONTCOLOR { 026, 052, 107 } TRANSPARENT     

 @ 404,359 LABEL Label_x9c VALUE "Dedicado  a  mi  esposa  Khadija  -  Marzo 2010 " AUTOSIZE ;
                    FONT "Arial" SIZE 10 BOLD ITALIC ;
                    FONTCOLOR { 026, 052, 107 } TRANSPARENT     


 @ 456,532 LABEL Label_x10c VALUE "- Mustafa Lpez" ;
                    FONT "Arial" SIZE 9 BOLD ITALIC  FONTCOLOR {026,052,107} ; 
                    WIDTH 245 HEIGHT 20
  
*---------------------------------------*

         DEFINE hyperlink email
            row 456
            col 390
            FONTNAME "Arial"
            FONTSIZE 9
            FONTBOLD .T.
            FONTITALIC .T. 
            value "mustalopez@gmail.com"
            transparent .t.
            width 200
            handcursor .t.
            address "mustalopez@gmail.com"
            FONTCOLOR {026,052,107} 
         END hyperlink

      end page

   END TAB
        DEFINE STATUSBAR font "Arial"
            KEYBOARD
            STATUSITEM " WinPrg 3.04 - Mustafa Lpez - mustalopez@gmail.com"  width  350
            DATE
            CLOCK
        END STATUSBAR

 END WINDOW

*---------------------------------------------   TOOLTIP   ----------------------------------------------------*

       SendMessageString( GetFormToolTipHandle ("Form_1"), TTM_SETTITLE, TTI_INFO, "Atencin" )  

*--------------------------------------------------------------------------------------------------------------*

  center window Form_1

  activate window Form_1

RETURN NIL


*--------------------------------------------------------------------------------------------------*
*------------------------------------------*   Procedures  *---------------------------------------*
*--------------------------------------------------------------------------------------------------*


*----------------------------------------   Window sin Base de Datos ------------------------------*

procedure sinficherox

aProgram:= Form_1.Texto_00.value

aNombre:= Form_1.Texto_01.value

aWin00:= Form_1.Texto_02.value

*------------------------------*
aWin01:= ( IIF(Form_1.CheckBoxC_01.Value,"True","False") )

If aWin01 = "True"
    aWinum01 = "600 x 400"
    aWinum02 = "         "
    aWinum03 = "          "
ENDIF
aWin02:= ( IIF(Form_1.CheckBoxC_02.Value,"True","False") )

If aWin02 = "True"
    aWinum01 = "         "
    aWinum02 = "800 x 600"
    aWinum03 = "          "
ENDIF
aWin03:= ( IIF(Form_1.CheckBoxC_03.Value,"True","False") )

If aWin03 = "True"
    aWinum01 = "         "
    aWinum02 = "         "
    aWinum03 = "1100 x 800"
ENDIF

aWin04:= ( IIF(Form_1.CheckBoxC_04.Value,"True","False") )

If aWin04 = "True"
    aWinum04 = "MAIN"
    aWinum05 = "     "

ENDIF
If aWin04 = "False"
    aWinum04 = "     "
    aWinum05 = "MODAL"
ENDIF

aWin05:= ( IIF(Form_1.CheckBoxC_05.Value,"True","False") )

If aWin05 = "True"
    aWinum06 = "MAXIMIZE"
    aWinum07  = "          "
ENDIF
If aWin05 = "False"
    aWinum06 = "        "
    aWinum07 = "NOMAXIMIZE"
ENDIF

aWin06:= ( IIF(Form_1.CheckBoxC_06.Value,"True","False") )

If aWin06 = "True"
    aWinum08 = "BOTONES"
    aWinum09  = "       "
ENDIF
If aWin06 = "False"
    aWinum08 = "       "
    aWinum09 = "       "
ENDIF

aWin07:= ( IIF(Form_1.CheckBoxC_07.Value,"True","False") )

If aWin07 = "True"
    aWinum10 = "MENU"
ENDIF
If aWin07 = "False"
    aWinum10 = "    "
    aWinum11 = "    "
ENDIF

SAVE TO MEMUWIN ALL LIKE a*

winprg333()

RETURN NIL
*----------------------------------------   Window Con Base de Datos 6 Campos ------------------------------*

procedure ConFicherox

aProgram:= Form_1.Texto_00a.value

aNombre:= Form_1.Texto_01a.value

aWin00:= Form_1.Texto_02a.value

*------------------------------*
aWin01:= ( IIF(Form_1.CheckBoxC_01a.Value,"True","False") )

If aWin01 = "True"
    aWinum01 = "600 x 400"
    aWinum02 = "         "
    aWinum03 = "          "
ENDIF
aWin02:= ( IIF(Form_1.CheckBoxC_02a.Value,"True","False") )

If aWin02 = "True"
    aWinum01 = "         "
    aWinum02 = "800 x 600"
    aWinum03 = "          "
ENDIF
aWin03:= ( IIF(Form_1.CheckBoxC_03a.Value,"True","False") )

If aWin03 = "True"
    aWinum01 = "         "
    aWinum02 = "         "
    aWinum03 = "1100 x 800"
ENDIF

aWin04:= ( IIF(Form_1.CheckBoxC_04a.Value,"True","False") )

If aWin04 = "True"
    aWinum04 = "MAIN"
    aWinum05 = "     "

ENDIF
If aWin04 = "False"
    aWinum04 = "     "
    aWinum05 = "MODAL"
ENDIF

aWin05:= ( IIF(Form_1.CheckBoxC_05a.Value,"True","False") )

If aWin05 = "True"
    aWinum06 = "MAXIMIZE"
    aWinum07  = "          "
ENDIF
If aWin05 = "False"
    aWinum06 = "        "
    aWinum07 = "NOMAXIMIZE"
ENDIF

*------------------------------------------*
aNomFich  := ALLTRIM(Form_1.Texx_00a.value)
aCodeS    := ALLTRIM(Form_1.Texx_01a.value)
aFiNS     := ALLTRIM(Form_1.Texx_02a.value)
aLaNS     := ALLTRIM(Form_1.Texx_03a.value)
aBDateS   := ALLTRIM(Form_1.Texx_04a.value)
aMoneyS   := ALLTRIM(Form_1.Texx_05a.value)
aNotixS   := ALLTRIM(Form_1.Texx_06a.value)
aChecbo   := ( IIF(Form_1.CheckBoxx_1a.Value,"True","False") )
aCaNTXCDX := ( IIF(Form_1.CheckBoxx_2b.Value,"True","False") )

 IF aChecbo = "True"
   IF aCaNTXCDX = "True"
      SAVE TO MEMUCON ALL LIKE a*
      winprg334()
      RETURN NIL
   ENDIF
 ENDIF
 IF aChecbo = "True"
   IF aCaNTXCDX = "False"
      SAVE TO MEMUCON ALL LIKE a*
      winprg334()
      RETURN NIL
   ENDIF
 ENDIF

SAVE TO MEMUCON ALL LIKE a*

winprg334()

RETURN NIL
*-------------------------- Window Con Toda la Base de Datos y Menu ------------------------------*

*------------------------------*
Procedure ConFicheroxx()
*------------------------------*

aProgram:= Form_1.Texto_00a2.value

aNombre:= Form_1.Texto_01a2.value

aWin00:= Form_1.Texto_02a2.value

*------------------------------*
aWin01:= ( IIF(Form_1.CheckBoxC_01a2.Value,"True","False") )

If aWin01 = "True"
    aWinum01 = "600 x 400"
    aWinum02 = "         "
    aWinum03 = "          "
ENDIF
aWin02:= ( IIF(Form_1.CheckBoxC_02a2.Value,"True","False") )

If aWin02 = "True"
    aWinum01 = "         "
    aWinum02 = "800 x 600"
    aWinum03 = "          "
ENDIF
aWin03:= ( IIF(Form_1.CheckBoxC_03a2.Value,"True","False") )

If aWin03 = "True"
    aWinum01 = "         "
    aWinum02 = "         "
    aWinum03 = "1100 x 800"
ENDIF

aWin04:= ( IIF(Form_1.CheckBoxC_04a2.Value,"True","False") )

If aWin04 = "True"
    aWinum04 = "MAIN"
    aWinum05 = "     "

ENDIF
If aWin04 = "False"
    aWinum04 = "     "
    aWinum05 = "MODAL"
ENDIF

aWin05:= ( IIF(Form_1.CheckBoxC_05a2.Value,"True","False") )

If aWin05 = "True"
    aWinum06 = "MAXIMIZE"
    aWinum07  = "          "
ENDIF
If aWin05 = "False"
    aWinum06 = "        "
    aWinum07 = "NOMAXIMIZE"
ENDIF

*------------------------------------------*
aNomFich  := ALLTRIM(Form_1.Texx_00a2.value)

aChecbo   := ( IIF(Form_1.CheckBoxx_1a2.Value,"True","False") )
aCaNTXCDX := ( IIF(Form_1.CheckBoxx_2b2.Value,"True","False") )

 IF aChecbo = "True"
   IF aCaNTXCDX = "True"
      SAVE TO MEMUCON ALL LIKE a*
      winprg339xx()
      RETURN NIL
   ENDIF
 ENDIF
 IF aChecbo = "True"
   IF aCaNTXCDX = "False"
      SAVE TO MEMUCON ALL LIKE a*
      winprg339xx()
      RETURN NIL
   ENDIF
 ENDIF

SAVE TO MEMUCON ALL LIKE a*


winprg339xx()

RETURN NIL
*----------------------------------------   Window Con Toda la Base de Datos ------------------------------*

*--------------------------------*
Procedure ConFicheroxxx()
*--------------------------------*

aProgram:= Form_1.Texto_00a2.value

aNombre:= Form_1.Texto_01a2.value

aWin00:= Form_1.Texto_02a2.value

*-------------------------------*
aWin01:= ( IIF(Form_1.CheckBoxC_01a2.Value,"True","False") )

If aWin01 = "True"
    aWinum01 = "600 x 400"
    aWinum02 = "         "
    aWinum03 = "          "
ENDIF
aWin02:= ( IIF(Form_1.CheckBoxC_02a2.Value,"True","False") )

If aWin02 = "True"
    aWinum01 = "         "
    aWinum02 = "800 x 600"
    aWinum03 = "          "
ENDIF
aWin03:= ( IIF(Form_1.CheckBoxC_03a2.Value,"True","False") )

If aWin03 = "True"
    aWinum01 = "         "
    aWinum02 = "         "
    aWinum03 = "1100 x 800"
ENDIF

aWin04:= ( IIF(Form_1.CheckBoxC_04a2.Value,"True","False") )

If aWin04 = "True"
    aWinum04 = "MAIN"
    aWinum05 = "     "

ENDIF
If aWin04 = "False"
    aWinum04 = "     "
    aWinum05 = "MODAL"
ENDIF

aWin05:= ( IIF(Form_1.CheckBoxC_05a2.Value,"True","False") )

If aWin05 = "True"
    aWinum06 = "MAXIMIZE"
    aWinum07  = "          "
ENDIF
If aWin05 = "False"
    aWinum06 = "        "
    aWinum07 = "NOMAXIMIZE"
ENDIF

*------------------------------------------*
aNomFich  := ALLTRIM(Form_1.Texx_00a2.value)
aChecbo   := ( IIF(Form_1.CheckBoxx_1a2.Value,"True","False") )
aCaNTXCDX := ( IIF(Form_1.CheckBoxx_2b2.Value,"True","False") )

 IF aChecbo = "True"
   IF aCaNTXCDX = "True"
      SAVE TO MEMUCON ALL LIKE a*
      winprg334xx()
      RETURN NIL
   ENDIF
 ENDIF
 IF aChecbo = "True"
   IF aCaNTXCDX = "False"
      SAVE TO MEMUCON ALL LIKE a*
      winprg334xx()
      RETURN NIL
   ENDIF
 ENDIF

SAVE TO MEMUCON ALL LIKE a*

winprg334xx()

RETURN NIL

*----------------------  Window Con Toda la Base de Datos y Botones --------------------*

*----------------------------*
Procedure ConFicheroxxxx()
*----------------------------*

aProgram:= Form_1.Texto_00a2.value

aNombre := Form_1.Texto_01a2.value

aWin00  := Form_1.Texto_02a2.value

*------------------------------*
aWin01:= ( IIF(Form_1.CheckBoxC_01a2.Value,"True","False") )

If aWin01 = "True"
    aWinum01 = "600 x 400"
    aWinum02 = "         "
    aWinum03 = "          "
ENDIF
aWin02:= ( IIF(Form_1.CheckBoxC_02a2.Value,"True","False") )

If aWin02 = "True"
    aWinum01 = "         "
    aWinum02 = "800 x 600"
    aWinum03 = "          "
ENDIF
aWin03:= ( IIF(Form_1.CheckBoxC_03a2.Value,"True","False") )

If aWin03 = "True"
    aWinum01 = "         "
    aWinum02 = "         "
    aWinum03 = "1100 x 800"
ENDIF

aWin04:= ( IIF(Form_1.CheckBoxC_04a2.Value,"True","False") )

If aWin04 = "True"
    aWinum04 = "MAIN"
    aWinum05 = "     "

ENDIF
If aWin04 = "False"
    aWinum04 = "     "
    aWinum05 = "MODAL"
ENDIF

aWin05:= ( IIF(Form_1.CheckBoxC_05a2.Value,"True","False") )

If aWin05 = "True"
    aWinum06 = "MAXIMIZE"
    aWinum07  = "          "
ENDIF
If aWin05 = "False"
    aWinum06 = "        "
    aWinum07 = "NOMAXIMIZE"
ENDIF

aWin08:= ( IIF(Form_1.CheckBoxC_06a2.Value,"True","False") )

If aWin08 = "True"
    aWinum012 = "NUMERIC_E"        
ENDIF
If aWin08 = "False"
    aWinum012 = "NUMERIC_S"        
ENDIF

*-------------------------- Crear Estructura -------------------------*

 aNomFich:= "New\"+ALLTRIM(Form_1.Texx_00a2.value)

 ficherox := aNomFich +".DBF"
*--------------------------------------*
 IF .NOT. FILE (ficherox)
     MSGSTOP("Fichero No Existe","Atencin !!!")
     CLOSE DATABASES
     RETURN NIL
 ENDIF

 IF FILE ("TestEstr.dbf")
    CLOSE DATABASES
    ERASE ("TestEstr.dbf")
 ENDIF

USE &aNomFich
__dbCopyXStruct( "TestEstr" )

CLOSE DATABASES

*----------Field_Name------------*

PUBLIC aFinameAA
PUBLIC aFinameAB
PUBLIC aFinameAC
PUBLIC aFinameAD
PUBLIC aFinameAE
PUBLIC aFinameAF
PUBLIC aFinameAG
PUBLIC aFinameAH
PUBLIC aFinameAI
PUBLIC aFinameAJ

PUBLIC aFinameAK
PUBLIC aFinameAL
PUBLIC aFinameAM
PUBLIC aFinameAN
PUBLIC aFinameAO
PUBLIC aFinameAP
PUBLIC aFinameAQ
PUBLIC aFinameAR
PUBLIC aFinameAS

PUBLIC aFinameAT
PUBLIC aFinameAU
PUBLIC aFinameAV
PUBLIC aFinameAX
PUBLIC aFinameAY

*-------Field_Type --------------*

PUBLIC aFiTypeAA
PUBLIC aFiTypeAB
PUBLIC aFiTypeAC
PUBLIC aFiTypeAD
PUBLIC aFiTypeAE
PUBLIC aFiTypeAF
PUBLIC aFiTypeAG
PUBLIC aFiTypeAH
PUBLIC aFiTypeAI
PUBLIC aFiTypeAJ

PUBLIC aFiTypeAK
PUBLIC aFiTypeAL
PUBLIC aFiTypeAM
PUBLIC aFiTypeAN
PUBLIC aFiTypeAO
PUBLIC aFiTypeAP
PUBLIC aFiTypeAQ
PUBLIC aFiTypeAR
PUBLIC aFiTypeAS

PUBLIC aFiTypeAT
PUBLIC aFiTypeAU
PUBLIC aFiTypeAV
PUBLIC aFiTypeAX
PUBLIC aFiTypeAY

*-------Field_Len --------------*

PUBLIC aFiaLenAA
PUBLIC aFiaLenAB
PUBLIC aFiaLenAC
PUBLIC aFiaLenAD
PUBLIC aFiaLenAE
PUBLIC aFiaLenAF
PUBLIC aFiaLenAG
PUBLIC aFiaLenAH
PUBLIC aFiaLenAI
PUBLIC aFiaLenAJ

PUBLIC aFiaLenAK
PUBLIC aFiaLenAL
PUBLIC aFiaLenAM
PUBLIC aFiaLenAN
PUBLIC aFiaLenAO
PUBLIC aFiaLenAP
PUBLIC aFiaLenAQ
PUBLIC aFiaLenAR
PUBLIC aFiaLenAS

PUBLIC aFiaLenAT
PUBLIC aFiaLenAU
PUBLIC aFiaLenAV
PUBLIC aFiaLenAX
PUBLIC aFiaLenAY

*-------Field_Dec --------------*

PUBLIC aFiaDecAA
PUBLIC aFiaDecAB
PUBLIC aFiaDecAC
PUBLIC aFiaDecAD
PUBLIC aFiaDecAE
PUBLIC aFiaDecAF
PUBLIC aFiaDecAG
PUBLIC aFiaDecAH
PUBLIC aFiaDecAI
PUBLIC aFiaDecAJ

PUBLIC aFiaDecAK
PUBLIC aFiaDecAL
PUBLIC aFiaDecAM
PUBLIC aFiaDecAN
PUBLIC aFiaDecAO
PUBLIC aFiaDecAP
PUBLIC aFiaDecAQ
PUBLIC aFiaDEcAR
PUBLIC aFiaDecAS

PUBLIC aFiaDecAT
PUBLIC aFiaDecAU
PUBLIC aFiaDecAV
PUBLIC aFiaDecAX
PUBLIC aFiaDEcAY
*------------------------------*


                      USE TestEstr

                    Do while .not. eof()
                     *----------Field_Name------------*
                        aFinameAA := FIELD_NAME
                        skip
                        aFinameAB := FIELD_NAME
                        skip
                        aFinameAC := FIELD_NAME
                        skip
                        aFinameAD := FIELD_NAME
                        skip
                        aFinameAE := FIELD_NAME
                        skip
                        aFinameAF := FIELD_NAME
                        skip
                        aFinameAG := FIELD_NAME
                        skip
                        aFinameAH := FIELD_NAME
                        skip
                        aFinameAI := FIELD_NAME
                        skip
                        aFinameAJ := FIELD_NAME
                        skip
                        aFinameAK := FIELD_NAME
                        skip
                        aFinameAL := FIELD_NAME
                        skip
                        aFinameAM := FIELD_NAME
                        skip
                        aFinameAN := FIELD_NAME
                        skip
                        aFinameAO := FIELD_NAME
                        skip
                        aFinameAP := FIELD_NAME
                        skip
                        aFinameAQ := FIELD_NAME
                        skip
                        aFinameAR := FIELD_NAME
                        skip
                        aFinameAS := FIELD_NAME
                        skip
                        aFinameAT := FIELD_NAME
                        skip
                        aFinameAU := FIELD_NAME
                        skip
                        aFinameAV := FIELD_NAME
                        skip
                        aFinameAX := FIELD_NAME
                        skip
                        aFinameAY := FIELD_NAME
                        skip

                     ENDDO

                     USE TestEstr

                     Do while .not. eof()
                   *-------Field_Type --------------*

                        aFiTypeAA := FIELD_TYPE
                        skip
                        aFiTypeAB := FIELD_TYPE
                        skip
                        aFiTypeAC := FIELD_TYPE
                        skip
                        aFiTypeAD := FIELD_TYPE
                        skip
                        aFiTypeAE := FIELD_TYPE
                        skip
                        aFiTypeAF := FIELD_TYPE
                        skip
                        aFiTypeAG := FIELD_TYPE
                        skip
                        aFiTypeAH := FIELD_TYPE
                        skip
                        aFiTypeAI := FIELD_TYPE
                        skip
                        aFiTypeAJ := FIELD_TYPE
                        skip
                        aFiTypeAK := FIELD_TYPE
                        skip
                        aFiTypeAL := FIELD_TYPE
                        skip
                        aFiTypeAM := FIELD_TYPE
                        skip
                        aFiTypeAN := FIELD_TYPE
                        skip
                        aFiTypeAO := FIELD_TYPE
                        skip
                        aFiTypeAP := FIELD_TYPE
                        skip
                        aFiTypeAQ := FIELD_TYPE
                        skip
                        aFiTypeAR := FIELD_TYPE
                        skip
                        aFiTypeAS := FIELD_TYPE
                        skip
                        aFiTypeAT := FIELD_TYPE
                        skip
                        aFiTypeAU := FIELD_TYPE
                        skip
                        aFiTypeAV := FIELD_TYPE
                        skip
                        aFiTypeAX := FIELD_TYPE
                        skip
                        aFiTypeAY := FIELD_TYPE
                        skip

                  ENDDO

                    USE TestEstr

                  Do while .not. eof()
                  *-------Field_Len --------------*

                        aFiaLenAA := FIELD_LEN
                        skip
                        aFiaLenAB := FIELD_LEN
                        skip
                        aFiaLenAC := FIELD_LEN
                        skip
                        aFiaLenAD := FIELD_LEN
                        skip
                        aFiaLenAE := FIELD_LEN
                        skip
                        aFiaLenAF := FIELD_LEN
                        skip
                        aFiaLenAG := FIELD_LEN
                        skip
                        aFiaLenAH := FIELD_LEN
                        skip
                        aFiaLenAI := FIELD_LEN
                        skip
                        aFiaLenAJ := FIELD_LEN
                        skip
                        aFiaLenAK := FIELD_LEN
                        skip
                        aFiaLenAL := FIELD_LEN
                        skip
                        aFiaLenAM := FIELD_LEN
                        skip
                        aFiaLenAN := FIELD_LEN
                        skip
                        aFiaLenAO := FIELD_LEN
                        skip
                        aFiaLenAP := FIELD_LEN
                        skip
                        aFiaLenAQ := FIELD_LEN
                        skip
                        aFiaLenAR := FIELD_LEN
                        skip
                        aFiaLenAS := FIELD_LEN
                        skip
                        aFiaLenAT := FIELD_LEN
                        skip
                        aFiaLenAU := FIELD_LEN
                        skip
                        aFiaLenAV := FIELD_LEN
                        skip
                        aFiaLenAX := FIELD_LEN
                        skip
                        aFiaLenAY := FIELD_LEN
                        skip

                ENDDO

                USE TestEstr


                Do while .not. eof()

                      *-------Field_Dec --------------*

                        aFiaDecAA := FIELD_DEC
                        skip
                        aFiaDecAB := FIELD_DEC
                        skip
                        aFiaDecAC := FIELD_DEC
                        skip
                        aFiaDecAD := FIELD_DEC
                        skip
                        aFiaDecAE := FIELD_DEC
                        skip
                        aFiaDecAF := FIELD_DEC
                        skip
                        aFiaDecAG := FIELD_DEC
                        skip
                        aFiaDecAH := FIELD_DEC
                        skip
                        aFiaDecAI := FIELD_DEC
                        skip
                        aFiaDecAJ := FIELD_DEC
                        skip
                        aFiaDecAK := FIELD_DEC
                        skip
                        aFiaDecAL := FIELD_DEC
                        skip
                        aFiaDecAM := FIELD_DEC
                        skip
                        aFiaDecAN := FIELD_DEC
                        skip
                        aFiaDecAO := FIELD_DEC
                        skip
                        aFiaDecAP := FIELD_DEC
                        skip
                        aFiaDecAQ := FIELD_DEC
                        skip
                        aFiaDEcAR := FIELD_DEC
                        skip
                        aFiaDecAS := FIELD_DEC
                        skip
                        aFiaDecAT := FIELD_DEC
                        skip
                        aFiaDecAU := FIELD_DEC
                        skip
                        aFiaDecAV := FIELD_DEC
                        skip
                        aFiaDecAX := FIELD_DEC
                        skip
                        aFiaDEcAY := FIELD_DEC
                        skip
                    ENDDO
*-----------------------------------------*
aNomFich  := ALLTRIM(Form_1.Texx_00a2.value)
aChecbo   := ( IIF(Form_1.CheckBoxx_1a2.Value,"True","False") )
aCaNTXCDX := ( IIF(Form_1.CheckBoxx_2b2.Value,"True","False") )

IF aChecbo = "True"
  IF aCaNTXCDX = "True"
     SAVE TO MEMUCON ALL LIKE a*
     winprg440xx()
     RETURN NIL
   ENDIF
 ENDIF
 IF aChecbo = "True"
   IF aCaNTXCDX = "False"
      SAVE TO MEMUCON ALL LIKE a*
     winprg440xx()
      RETURN NIL
   ENDIF
 ENDIF

SAVE TO MEMUCON ALL LIKE a*

winprg440xx()

RETURN NIL

*-------------------------------------------------------------------------------*

*------------------------------------------------<  Crear Bases de Datos -------*
Procedure createtables()
*------------------------------------------------<  Crear Bases de Datos -------*

Local Nc, lc := 0 , lcV := array(4), aCrea := {}
Private ctemp := array(4)
declare local acArch
declare local acACDX
declare local acAFPT
declare local acANTX
declare local acADBT
declare local aCrea
declare local avis

acArch := "New\"+ALLTRIM(Form_1.Tex_00.value) +".DBF"

acACDX := "New\"+ALLTRIM(Form_1.Tex_00.value) +".CDX"

acAFPT := "New\"+ALLTRIM(Form_1.Tex_00.value) +".FPT"

acANTX := "New\"+ALLTRIM(Form_1.Tex_00.value) +".NTX"

acADBT := "New\"+ALLTRIM(Form_1.Tex_00.value) +".DBT"

avis := ALLTRIM(Form_1.Tex_00.value)

 IF avis < SPACE(1)
     MSGSTOP("Falta Nombre Fichero","Atencin !!!")
     CLOSE DATABASES
     RETURN NIL
 ENDIF

 IF FILE (acArch)
    CLOSE DATABASES
    ERASE (acArch)
 ENDIF
 IF FILE (acACDX)
    CLOSE DATABASES
    ERASE (acACDX)
 ENDIF
 IF FILE (acAFPT)
    CLOSE DATABASES
    ERASE (acAFPT)
 ENDIF

 IF FILE (acANTX)
    CLOSE DATABASES
    ERASE (acANTX)
 ENDIF
 IF FILE (acADBT)
    CLOSE DATABASES
    ERASE (acADBT)
 ENDIF

*------------------------------------------------------------------------------*

   For Nc = 1 to 96 step 4
       lc ++
       ctemp[1] := "Tex_"+ltrim( strzero( Nc  ,2 ) )
       ctemp[2] := "Tex_"+ltrim( strzero( Nc+1,2 ) )
       ctemp[3] := "Tex_"+ltrim( strzero( Nc+2,2 ) )
       ctemp[4] := "Tex_"+ltrim( strzero( Nc+3,2 ) )
       LcV[1] := "aNom"+ltrim( strzero( lc,2 ) )
       LcV[2] := "aTip"+ltrim( strzero( lc,2 ) )
       LcV[3] := "aNum"+ltrim( strzero( lc,2 ) )
       LcV[4] := "aDec"+ltrim( strzero( lc,2 ) )
       aeval(Lcv,{|x,y| &(x) := GETPROPERTY("Form_1",ctemp[y],"value")} )
       if !empty(GETPROPERTY("Form_1",ctemp[1],"value"))
           aadd (aCrea ,{GETPROPERTY("Form_1",ctemp[1],"value") ;
                       , GETPROPERTY("Form_1",ctemp[2],"value") ;
                       , GETPROPERTY("Form_1",ctemp[3],"value") ;
                       , GETPROPERTY("Form_1",ctemp[4],"value") } )
       Endif
   next
release cTemp

SAVE TO MEMUAR ALL LIKE a*

RESTORE FROM MEMUAR.MEM ADDITIVE

IF !file(acArch)

*-------------- Tipo de Fichero a Crear -------------------*

aCnTxcDx:= ( IIF(Form_1.CheckBoxx_bb.Value,"True","False") )

*----------------------------------------------------------*
   IF aCnTxcDx = "True"

        REQUEST DBFNTX , DBFDBT
        RDDSETDEFAULT( "DBFNTX" )

        dbCreate( acArch, aCrea,"DBFNTX")
   ENDIF
   IF aCnTxcDx = "False"

       REQUEST DBFCDX , DBFFPT
       RDDSETDEFAULT( "DBFCDX" )

       dbCreate( acArch, aCrea,"DBFCDX")
   ENDIF

*----------------------------------------------------------*
ENDIF

aCrea := {}

*------------------------------------------------------------*

 declare local aNomFichD

 aNomFichD:= "New\"+ALLTRIM(Form_1.Tex_00.value)

 ficheroxD := aNomFichD +".DBF"

 IF .NOT. FILE (ficheroxD)
     MSGSTOP("Fichero No Existe","Atencin !!!")
     CLOSE DATABASES
     RETURN NIL
 ENDIF

 IF FILE ("TestEstr.dbf")
    CLOSE DATABASES
    ERASE ("TestEstr.dbf")
 ENDIF

USE &aNomFichD
__dbCopyXStruct( "TestEstr" )

*----------------------------------------------------------*
   CLOSE DATABASES
   COPY FILE ("TestEstr.DBF") TO ("TEMPOR_S.DBF")
   CLOSE DATABASES
   SELECT 1
   USE TEMPOR_S
   GO TOP
DO WHILE .NOT. EOF()

   IF FIELD_TYPE ="L"
      REPLACE FIELD_LEN WITH 1
      REPLACE FIELD_DEC WITH 0
   ENDIF
   IF FIELD_TYPE ="D"
      REPLACE FIELD_LEN WITH 8
      REPLACE FIELD_DEC WITH 0
   ENDIF
   IF FIELD_TYPE ="M"
      REPLACE FIELD_LEN WITH 10
      REPLACE FIELD_DEC WITH 0
   ENDIF
   IF FIELD_TYPE ="C"
      IF FIELD_LEN > 999
         REPLACE FIELD_LEN WITH 999
         REPLACE FIELD_DEC WITH 0
      ENDIF
   ENDIF
   IF FIELD_TYPE ="C"
         REPLACE FIELD_DEC WITH 0
   ENDIF

   IF FIELD_TYPE ="N"
      IF FIELD_LEN > 19
         REPLACE FIELD_LEN WITH 19
      ENDIF
   ENDIF
   IF FIELD_TYPE ="N"
      IF FIELD_DEC  > 17
         REPLACE FIELD_DEC WITH 17
      ENDIF
   ENDIF

   IF FIELD_TYPE <> "C" .AND. FIELD_TYPE <> "N" .AND.  FIELD_TYPE <>"D" .AND. FIELD_TYPE <>"L" .AND. FIELD_TYPE <> "M"
      REPLACE FIELD_TYPE WITH " "
      REPLACE FIELD_LEN WITH 0
      REPLACE FIELD_DEC WITH 0
  ENDIF

  SKIP

ENDDO

*--------------------------  Final -----------------------------*
   DELETE FOR FIELD_TYPE = " "
   PACK
   CLOSE DATABASES
   CREATE &acArch FROM TEMPOR_S
   use &acArch
   APPEND BLANK
   CLOSE DATABASES
   ERASE('TestEstr.DBF')
   ERASE('TEMPOR_S.DBF')

*--------------------------- Indexar ---------------------------*

aInTxcDx:= ( IIF(Form_1.CheckBoxx_aa.Value,"True","False") )

*------------------------- Indexar NTX  ------------------------*

If aInTxcDx = "True"

    REQUEST DBFNTX , DBFDBT
    RDDSETDEFAULT( "DBFNTX" )

    USE &acArch Via "DBFNTX"

    Append Blank

    acANTX := "New\"+ALLTRIM(Form_1.Tex_00.value) +".ntx"

    NUM:= (Form_1.Tex_97.value)

    SAVE TO MEMNUME ALL LIKE NUM*

  IF NUM > 0 .AND. NUM < 25

    USE &acArch
    mcamp=FIELD(NUM)

      IF TYPE(FIELD(NUM))="L"
           CLOSE DATABASES
           RETURN NIL
      ENDIF

      IF TYPE(FIELD(NUM))="M"
          CLOSE DATABASES
          RETURN NIL
       ENDIF

      IF TYPE(FIELD(NUM)) <> "C" .AND. TYPE(FIELD(NUM)) <> "N" .AND. TYPE(FIELD(NUM)) <>"D" .AND. TYPE(FIELD(NUM)) <>"L" .AND. TYPE(FIELD(NUM)) <> "M"
          CLOSE DATABASES
          RETURN NIL
      ENDIF

      IF TYPE(FIELD(NUM))="C"
          INDEX ON &mcamp TO &acANTX
          CLOSE DATABASES
          RETURN NIL
      ENDIF

      IF TYPE(FIELD(NUM))="N"
          INDEX ON STR(&mcamp) TO &acANTX
        ELSE
          INDEX ON &mcamp TO &acANTX
          CLOSE DATABASES
          RETURN NIL
       ENDIF

       IF TYPE(FIELD(NUM))="D"
          INDEX ON DTOS(&mcamp) TO &acANTX
         ELSE
          INDEX ON &mcamp TO &acANTX
          CLOSE DATABASES
          RETURN NIL
       ENDIF
    RETURN nil
  ENDIF

   RETURN NIL

ENDIF
*--------------------------- Indexar CDX -------------------------*
If aInTxcDx = "False"

   REQUEST DBFCDX , DBFFPT
   RDDSETDEFAULT( "DBFCDX" )

   USE &acArch Via "DBFCDX"

   Append Blank

   acACDX := "New\"+ALLTRIM(Form_1.Tex_00.value) +".cdx"

   NUM:= (Form_1.Tex_97.value)

   SAVE TO MEMNUME ALL LIKE NUM*

  IF NUM > 0 .AND. NUM < 25

    USE &acArch
    mcamp=FIELD(NUM)

      IF TYPE(FIELD(NUM))="L"
           CLOSE DATABASES
           RETURN NIL
      ENDIF

      IF TYPE(FIELD(NUM))="M"
          CLOSE DATABASES
          RETURN NIL
       ENDIF

      IF TYPE(FIELD(NUM)) <> "C" .AND. TYPE(FIELD(NUM)) <> "N" .AND. TYPE(FIELD(NUM)) <>"D" .AND. TYPE(FIELD(NUM)) <>"L" .AND. TYPE(FIELD(NUM)) <> "M"
          CLOSE DATABASES
          RETURN NIL
      ENDIF

      IF TYPE(FIELD(NUM))="C"
          INDEX ON &mcamp TO &acACDX
          CLOSE DATABASES
          RETURN NIL
      ENDIF

      IF TYPE(FIELD(NUM))="N"
          INDEX ON STR(&mcamp) TO &acACDX
        ELSE
          INDEX ON &mcamp TO &acACDX
          CLOSE DATABASES
          RETURN NIL
       ENDIF

       IF TYPE(FIELD(NUM))="D"
          INDEX ON DTOS(&mcamp) TO &acACDX
         ELSE
          INDEX ON &mcamp TO &acACDX
          CLOSE DATABASES
          RETURN NIL
       ENDIF
    RETURN nil
  ENDIF

  RETURN NIL

ENDIF

*----------------------------------------   Procedures Ayuda ----------------------------*

*-----------------------*
Procedure aYudax()
*-----------------------*

        LOCAL cFileSX, cContenidoX, cLinea
	LOCAL i := 0, nLineas := 0

	cFileSX = 'Files\Ayuda.txt'
	cContenidoX := MEMOREAD( cFileSX )


          DEFINE WINDOW FrmAyuda;
               AT 0,0 ;
	       WIDTH 629 HEIGHT 459 ;
               BACKCOLOR {000,124,000}; 
               TITLE ' [ Esc ] <- Cancelar'+ SPACE(42)+'Ayuda'  ;                          
               CHILD NOSYSMENU CURSOR "" NOSIZE NOMAXIMIZE                                    
               ON KEY ESCAPE ACTION FrmAyuda.Release

		DEFINE EDITBOX EDIT1x
			ROW 7
			COL 7
                        WIDTH 610      
			HEIGHT 414      
                        BACKCOLOR {227,229,239}			
			VALUE cContenidoX
			FONTNAME 'Courier New'
			FONTSIZE 9
                        READONLY .T.
		END EDITBOX
	END WINDOW
	FrmAyuda.center
	ACTIVATE WINDOW FrmAyuda
   RETURN

*--------------------------------------     Procedures Help  ----------------------------*

*----------------------*
Procedure aYudaxI()
*----------------------*

        LOCAL cFileSXI, cContenidoXI, cLineaI
	LOCAL iI := 0, nLineasI := 0

	cFileSXI = 'Files\Help.txt'
	cContenidoXI := MEMOREAD( cFileSXI )
		
           DEFINE WINDOW FrmAyudaI;
		AT 0,0 ;
	        WIDTH 629 HEIGHT 459 ;
                BACKCOLOR {000,124,000}; 
                TITLE ' [ Esc ] <- Cancelar'+ SPACE(42)+'Help'  ;                          
                CHILD NOSYSMENU CURSOR "" NOSIZE NOMAXIMIZE                                    
                ON KEY ESCAPE ACTION FrmAyudaI.Release

		DEFINE EDITBOX EDIT1xI
			ROW 7
			COL 7
			WIDTH 610  
			HEIGHT 414 
                        BACKCOLOR {227,229,239}	
			VALUE cContenidoXI
			FONTNAME 'Courier New'
			FONTSIZE 9
                        READONLY .T.
		END EDITBOX
	END WINDOW
	FrmAyudaI.center
	ACTIVATE WINDOW FrmAyudaI
   RETURN

*-----------------------------------------  Procedures de Ver Browse  -----------------------------*

*----------------------------*
Procedure  VerBrowse()
*----------------------------*

aNomFich := ALLTRIM(Form_1.Texx_00.value)

aChecbo  := ( IIF(Form_1.CheckBoxx_1.Value,"True","False") )
aCIntxcdx:= ( IIF(Form_1.CheckBoxx_2.Value,"True","False") )

 IF aNomFich < SPACE(1)
        MSGSTOP("Fichero DBF No Existe","Atencin !!!")
        CLOSE DATABASES
        RETURN NIL
 ENDIF

 IF aChecbo = "True"
    If aCIntxcdx = "True"
       SAVE TO MEMDBF ALL LIKE a*
       AUXILIAR()
       RETURN NIL
    ENDIF
 ENDIF

 IF aChecbo = "True"
    If aCIntxcdx = "False"
       SAVE TO MEMDBF ALL LIKE a*
       AUXILIAR()
       RETURN NIL
    ENDIF
ENDIF

SAVE TO MEMDBF ALL LIKE a*

AUXILIAR()

Return Nil

*----------------- Crear Estructura -----------------------*

*--------------------------------*
Procedure CrearEstructura()
*--------------------------------*

 aNomFich := ALLTRIM(Form_1.Texx_00.value)

 SAVE TO VEREST ALL LIKE aNomFich*

 aNomFich:= "New\"+ALLTRIM(Form_1.Texx_00.value)

 ficherox := aNomFich +".DBF"

*--------------------------------------*
  IF .NOT. FILE (ficherox)
     MSGSTOP("Fichero No Existe","Atencin !!!")
     CLOSE DATABASES
     RETURN NIL
 ENDIF

 IF FILE ("TestEstr.dbf")
    CLOSE DATABASES
    ERASE ("TestEstr.dbf")
 ENDIF

SAVE TO MEMEST ALL LIKE aNomFich*

USE &aNomFich
__dbCopyXStruct( "TestEstr" )

 CLOSE DATABASES

 baseESTA()

Return Nil

*--------------------------------------------  Editor Prg -------------------------------------*

*-------------------------------------------*
Procedure ShowRowCol()
*-------------------------------------------*

Local s , c , i , e , q , colum
	
	s := Form_1.Edit_1P.Value
	c := Form_1.Edit_1P.CaretPos
	e := 0
	q := 0

	for i := 1 to c
		if substr ( s , i , 1 ) == chr(13)  
			e++
			q := 0
		Else
			q++    
		EndIf
	Next i
                           
        Form_1.L_1.Value := 'Lnea: '+SPACE(1) + alltrim(Str(e+1)) + SPACE(3) +' Columna: '+ SPACE(1) + alltrim(Str(q-1))
   
Return

*-------------------------------------------*
Procedure Limpia()
*-------------------------------------------*
Form_1.Edit_1P.value:=" "

RETURN

*-------------------------------------------*
Procedure SalvaFichero()
*-------------------------------------------*
fix = Form_1.Tex_1P.value

 IF fix < SPACE(1)
      msginfo("No se ha elejido Archivo "," Atencin !!!")
     RETURN
 ENDIF

 cContenido := Form_1.Edit_1P.value

 IF cContenido < SPACE(1)
    MSGSTOP("No se escribi Texto "," Atencin !!!")
    Form_1.Tex_1P.value:=" "
    RETURN NIL
 ENDIF

 ***  cFileD = "Doc_Prg\"+ LOWER(ALLTRIM(fix)) + ".prg"
 cFileD = "New\"+ LOWER(ALLTRIM(fix)) + ".prg"
 MEMOWRIT(cFileD,MEMOREAD(cFileD),.T.)
 Form_1.Tex_1P.value:=" "

   IF MEMOWRIT(cFileD,cContenido,.T.) 
      Form_1.Edit_1P.value:=" "
      SAVE TO memuar ALL LIKE cFileD*  
      PASO()  
   ENDIF

 RETURN

*-------------------------------------------*
Procedure BuscaFichero()
*-------------------------------------------*
 Public cFileD := GetFile({{'prg','*.prg'},;
 {'All files','*.*'}})

 SetCurrentFolder( cPrgFolder )

 IF .NOT. FILE (cFileD)
      msginfo("No se ha elejido archivo "," ATENCION !!!")
     RETURN
 ENDIF

 cContenido := MEMOREAD( cFileD )

 Form_1.Edit_1P.value:=cContenido

 RETURN


*-------------------------------------------*
  Procedure TextoGraba()
*-------------------------------------------*

  Cfile:=putfile({{'prg','*.prg'}},"Grab\arArchivo")

  cContenido := Form_1.Edit_1P.value

  IF cContenido < SPACE(1)
    MSGSTOP("No se escribi Texto "," Atencin !!!")
    RETURN NIL
  ENDIF

  IF  "." $ Cfile
    CfileD := LOWER(ALLTRIM(Cfile))
  ELSE
    CfileD := LOWER(ALLTRIM(Cfile)) + ".prg"
  ENDIF

  SetCurrentFolder( cPrgFolder )

  IF MEMOWRIT(CFileD,cContenido,.T.)
      SAVE TO memuar ALL LIKE cFileD* 
    ELSE
     msginfo("No se pudo grabar el Archivo "," Atencin !!!")
    RETURN
  ENDIF

 PASO()

*--------------------------------------------*
 Procedure PASO()
*--------------------------------------------*
 RESTORE FROM memuar.mem ADDITIVE

 ficherAaX := RIGHT( cFileD , LEN(cFileD) - RAT("\", cFileD ))  

 SAVE TO memuar1 ALL LIKE ficherAaX  

*--------------------- 0 Letra + ".Prg" =  4 Digitos ------------------*

 IF LEN(ficherAaX) = 4
      Nuevo =  LEFT (ficherAaX, 0) 
 
      MSGSTOP("No Indic Nombdre Fichero","Atencin !!!")
       ERASE (".prg")
       ERASE (".prg.prg")    
       ERASE ("New\.prg")               //  ----------->  de a cambiado Doc_Prg\
       ERASE ("New\.prg.prg")           //  ----------->  de a cambiado Doc_Prg\
      RETURN NIL 
 
 ENDIF

*--------------------- 1 Letra + ".Prg" =  5 Digitos ------------------*

 IF LEN(ficherAaX) = 5

     Nuevo =  LEFT (ficherAaX, 1) 

     SAVE TO memuar2 ALL LIKE Nuevo      

 ENDIF

*--------------------- 2 Letra + ".Prg" =  6 Digitos ------------------*

 IF LEN(ficherAaX) = 6

     Nuevo =  LEFT (ficherAaX, 2) 

     SAVE TO memuar2 ALL LIKE Nuevo      

 ENDIF

*--------------------- 3 Letra + ".Prg" =  7 Digitos ------------------*

 IF LEN(ficherAaX) = 7

     Nuevo =  LEFT (ficherAaX, 3) 

     SAVE TO memuar2 ALL LIKE Nuevo      

 ENDIF

*--------------------- 4 Letra + ".Prg" =  8 Digitos ------------------*

 IF LEN(ficherAaX) = 8

     Nuevo =  LEFT (ficherAaX, 4) 

     SAVE TO memuar2 ALL LIKE Nuevo      

 ENDIF

*--------------------- 5 Letra + ".Prg" =  9 Digitos ------------------*

 IF LEN(ficherAaX) = 9

     Nuevo =  LEFT (ficherAaX, 5) 

     SAVE TO memuar2 ALL LIKE Nuevo      

 ENDIF
 
*--------------------- 6 Letra + ".Prg" = 10 Digitos ------------------*

 IF LEN(ficherAaX) = 10

     Nuevo =  LEFT (ficherAaX, 6) 

     SAVE TO memuar2 ALL LIKE Nuevo      

 ENDIF

*--------------------- 7 Letra + ".Prg" = 11 Digitos ------------------*

 IF LEN(ficherAaX) = 11

     Nuevo =  LEFT (ficherAaX, 7) 

     SAVE TO memuar2 ALL LIKE Nuevo      

 ENDIF

*--------------------- 8 Letra + ".Prg" = 12 Digitos ------------------*

 IF LEN(ficherAaX) = 12

     Nuevo =  LEFT (ficherAaX, 8) 

     SAVE TO memuar2 ALL LIKE Nuevo      

 ENDIF
*----------------------------------------------------------------------*
*--------------------- 9 Letra + ".Prg" = 13 Digitos ------------------*

 IF LEN(ficherAaX) = 13

     Nuevo =  LEFT (ficherAaX, 9) 

     SAVE TO memuar2 ALL LIKE Nuevo      

 ENDIF
*--------------------- 10 Letra + ".Prg" = 14 Digitos ------------------*

 IF LEN(ficherAaX) = 14

     Nuevo =  LEFT (ficherAaX, 10) 

     SAVE TO memuar2 ALL LIKE Nuevo      

 ENDIF
*--------------------- 11 Letra + ".Prg" = 15 Digitos ------------------*

 IF LEN(ficherAaX) = 15

     Nuevo =  LEFT (ficherAaX, 11) 

     SAVE TO memuar2 ALL LIKE Nuevo      

 ENDIF
*--------------------- 12 Letra + ".Prg" = 16 Digitos ------------------*

 IF LEN(ficherAaX) = 16

     Nuevo =  LEFT (ficherAaX, 12) 

     SAVE TO memuar2 ALL LIKE Nuevo      

 ENDIF
*--------------------- 13 Letra + ".Prg" = 17 Digitos ------------------*

 IF LEN(ficherAaX) = 17

     Nuevo =  LEFT (ficherAaX, 13) 

     SAVE TO memuar2 ALL LIKE Nuevo      

 ENDIF
*--------------------- 14 Letra + ".Prg" = 18 Digitos ------------------*

 IF LEN(ficherAaX) = 18

     Nuevo =  LEFT (ficherAaX, 14) 

     SAVE TO memuar2 ALL LIKE Nuevo      

 ENDIF
*--------------------- 15 Letra + ".Prg" = 19 Digitos ------------------*

 IF LEN(ficherAaX) = 19

     Nuevo =  LEFT (ficherAaX, 15) 

     SAVE TO memuar2 ALL LIKE Nuevo      

 ENDIF
*--------------------- 16 Letra + ".Prg" = 20 Digitos ------------------*

 IF LEN(ficherAaX) = 20

     Nuevo =  LEFT (ficherAaX, 16) 

     SAVE TO memuar2 ALL LIKE Nuevo      

 ENDIF

*--------------------- 17 Letra + ".Prg" = 21 Digitos ------------------*

 IF LEN(ficherAaX) = 21

     Nuevo =  LEFT (ficherAaX, 17) 

     SAVE TO memuar2 ALL LIKE Nuevo      

 ENDIF

*--------------------- 18 Letra + ".Prg" = 22 Digitos ------------------*

 IF LEN(ficherAaX) = 22

     Nuevo =  LEFT (ficherAaX, 18) 

     SAVE TO memuar2 ALL LIKE Nuevo      

 ENDIF

*--------------------- 19 Letra + ".Prg" = 23 Digitos ------------------*

 IF LEN(ficherAaX) = 23

     Nuevo =  LEFT (ficherAaX, 19) 

     SAVE TO memuar2 ALL LIKE Nuevo      

 ENDIF

*--------------------- 20 Letra + ".Prg" = 24 Digitos ------------------*

 IF LEN(ficherAaX) = 24

     Nuevo =  LEFT (ficherAaX, 20) 

     SAVE TO memuar2 ALL LIKE Nuevo      

 ENDIF

*--------------------- 21 Letra + ".Prg" = 25 Digitos ------------------*

 IF LEN(ficherAaX) = 25

     Nuevo =  LEFT (ficherAaX, 21) 

     SAVE TO memuar2 ALL LIKE Nuevo      

 ENDIF

*--------------------- 22 Letra + ".Prg" = 26 Digitos ------------------*

 IF LEN(ficherAaX) = 26

     Nuevo =  LEFT (ficherAaX, 22) 

     SAVE TO memuar2 ALL LIKE Nuevo      

 ENDIF

*----------------------------------------------------------------------*
*----------------------------------------------------------------------*

 fichero := "New\"+ALLTRIM(Nuevo)+".prg"           //  ----------->  de a cambiado Doc_Prg\

 ficher  := "New\"+ALLTRIM(Nuevo)              //  ----------->  de a cambiado Doc_Prg\

 fichaq  := LOWER(ALLTRIM(Nuevo))

*-----------------------------------------------------------------------*
*-----------------------------------------------------------------------*

RESTORE FROM memuar2 ADDITIVE  

 IF LEN(nuevo) <= 8 

  FDIA   := DTOC(DATE()) 
  FDIAx  := STRTRAN(FDIA, '/')                  && eliminas la barra(/) 
  HORA   := LEFT(TIME(), 5) 
  HORAx  := STRTRAN(HORA, ':')                  && eliminas los dos puntos(:) 
  newprg := "Bak_Prg\" + fichaq + "_" + FDIAx + '_' + HORAx + '.prg' 

  IF MEMOWRIT( newprg ,cContenido,.T.)
    ELSE
     msginfo("No se pudo grabar el archivo"+ CRLF ;
              + "Respaldo:"+ SPACE(2) + fichaq ,"Atencin!!!")    
    RETURN
  ENDIF

 ENDIF

  IF LEN(nuevo) >= 9 
    msginfo("No se pudo grabar el archivo"+ CRLF ;
             + "Respaldo:"+ SPACE(2) + fichaq ,"Atencin!!!")
  ENDIF   
   
  Form_1.Edit_1P.value:="  "

      ERASE (".prg")
      ERASE (".prg.prg")       
      ERASE ("New\.prg")                      //  ----------->  de a cambiado Doc_Prg\
      ERASE ("New\.prg.prg")                  //  ----------->  de a cambiado Doc_Prg\

*------------------ visor ltimo Fichero Grabado ------------*

 *****   Form_1.Label_3F.value := ALLTRIM( FICHERAAX)   //  no borrar si se quiere Label o TexBox en el visor 
  Form_1.Tex_0V.value := ALLTRIM( FICHERAAX) 

  RETURN NIL

*-------------------------------------------*
Procedure Borrax()
*-------------------------------------------*
 Public cFileFx := GetFile({{'prg','*.prg'},;
 {'All files','*.*'}})

 SetCurrentFolder( cPrgFolder )

 IF .NOT. FILE (cFileFx)
      msginfo("No se ha elejido archivo "," ATENCION !!!")
     RETURN
 ENDIF

 cContenido := MEMOREAD( cFileFx )

 Form_1.Edit_1P.value:=cContenido

  IF MsgYesNo("Desea Borrar Fichero ?","ATENCION !!!") = .T.

	   ERASE (cFileFx)
                 Form_1.Edit_1P.value:="  "
		 Return .T.
  EndIf

  Form_1.Edit_1P.value:="  "

 RETURN .F.

*------------------------------------------  Compilar Ficheros PRG ---------------------*

*-------------------------------------------*
  Procedure PreCompila()
*-------------------------------------------*

  aCompil := ALLTRIM(Form_1.Tex_1c.value)
  
  aCompiX := "New\" + ALLTRIM(Form_1.Tex_1c.value) +".prg"

  SAVE TO COMPILI ALL LIKE aCompil*

  RESTORE FROM COMPILI.mem ADDITIVE

  IF .NOT. FILE(aCompiX)
      MSGSTOP("Nombre Programa No es Correcto","Atencin !!!") 
      CLOSE DATABASES
      RETURN NIL
  ENDIF 

  IF aCompil <= space(1)
     MSGSTOP("Falta nombre Programa","Atencin !!!")
     CLOSE DATABASES
     RETURN NIL
  ENDIF

  AnteEXE := "New\"+ALLTRIM( aCompil ) + ".exe"

  IF FILE(AnteEXE)
     ERASE (AnteEXE)
  ENDIF

  BarraD()

  RETURN

*------------------------------------------* 
 Procedure Compilarx()
*------------------------------------------*

  aCompil := ALLTRIM(Form_1.Tex_1c.value)
  
  SAVE TO COMPILI ALL LIKE aCompil*

  IF FILE("MASTER.DBF")
     USE MASTER
     COPY TO ("CREA.DBF")
  ENDIF
  CLOSE DATABASES
  RESTORE FROM COMPILI.mem ADDITIVE
  *-----------------------------------*
  IF aCompil <= space(1)
     MSGSTOP("Falta nombre Programa","Atencin !!!")
     CLOSE DATABASES
     RETURN NIL
  ENDIF

  *---------------  Crear el Fichero BaT ------------*
    SELECT 1
    USE CREA
    REPLACE NOMBRE WITH "@ECHO OFF"
    SELECT 1
    USE CREA
    SKIP 1
    REPLACE NOMBRE WITH "CLS"
    SELECT 1
    USE CREA
    SKIP 2
    REPLACE NOMBRE WITH "cd New"
    SELECT 1
    USE CREA
    SKIP 3
    REPLACE NOMBRE WITH "START /MIN build.bat"+" "+ALLTRIM(aCompil)   
    SELECT 1
    USE CREA
    SKIP 4
    REPLACE NOMBRE WITH "CLS" 
    SELECT 1
    USE CREA
    SKIP 5
    REPLACE NOMBRE WITH "EXIT"

 * --------------Ejecutar Fichero BAT ---------------*
  Cnuevo = "Gestion.bat"

  IF FILE("CREA.DBF")

          COPY TO &Cnuevo ;
          FIELDS nombre FOR NOMBRE >= "  " DELIMITED WITH BLANK

  ENDIF

        RUN ("Gestion.bat")

          CLOSE DATABASES
          ERASE('CREA.DBF')
          ERASE('Gestion.bat')

 RETURN NIL
 *--------------------- Salir -----------------------*

*-------------------------------------------*
 PROCEDURE FinalProgram()
*-------------------------------------------*

 IF MsgYesNo("Desea Finalizar Programa ?","ATENCION !!!") = .T.
    Form_1.Release
    Return .T.
 EndIf
 
 RETURN NIL
*----------------------------------------------------*

*----------------------------------------- Incluir para -> TOOLTIP ---------------------------*  
#pragma BEGINDUMP

#include <windows.h>
#include "hbapi.h"

HB_FUNC ( SENDMESSAGESTRING )
{
  hb_retnl( (LONG) SendMessage( (HWND) hb_parnl(1), (UINT) hb_parni(2), (WPARAM) hb_parnl(3), (LPARAM) (LPSTR) hb_parc(4) ) );
}

#pragma ENDDUMP

*---------------------------------------*























